
#    Note:  This is loaded into the namespace  CAENX

#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""

    variable allmodules 0

   proc  show_variables {} {
       variable allmodules 

       InsertLog "all modules = $allmodules"
        InsertLog "ConfigBase=$::VMEConfig::ConfigBase"
        InsertLog "ModuleMenu=$::VMEConfig::ModuleMenu"
   }

      proc do_Initialise {} {
        global errorCode errorInfo

        InsertLog "Restoring VME Configuration"
puts "Restoring VME Configuration"
        set rc [catch {Inform VMEConfig doRestore} m]
        InsertLog "VMEConfig Restore returns $rc $m"
puts "VMEConfig Restore returns $rc $m"
        if {$rc != 0} {
           set rc $errorCode
           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
        }
        InsertLog "OK"

        InsertLog "Activating VME Configuration"
puts "Activating VME Configuration"
        set rc [catch {Inform VMEConfig do_Activate} m]
        InsertLog "VMEConfig Activate returns $rc $m"
puts "VMEConfig Activate returns $rc $m"
        if {$rc != 0} {
           set rc $errorCode
           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
        }
        InsertLog "OK"

#        InsertLog "Initialise VME registers"

#        set rc [catch {InitialiseVMERegisters "*"} m]
#        InsertLog "Initialise returns $rc $m"
#        if {$rc != 0} {
#           set rc $errorCode
#           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
#       }

        InsertLog "Restore VME Settings"
puts "Restore VME Settings"
        set rc [catch {Inform VMESaveRestore doRestore} m]
        InsertLog "VME Restore returns $rc $m"
puts "VME Restore returns $rc $m"
        if {$rc != 0} {
           set rc $errorCode
           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
        }
        InsertLog "OK"

        InsertLog "Run ADC Calibration"
puts "Run ADC Calibration"
        foreach m $::VMEConfig::ModuleMenu {
            set module [string range $m 5 end]
            switch $module {
               V1725PHA -
               V1730PHA -
               V1725PSD -
               V1730PSD -
               V1751PSD {
                 set rc [catch {Inform $module do_Calibration} msg]
                 InsertLog "Run ADC Calibration for $m returns $rc $msg"
                 if {$rc != 0} {
                    set rc $errorCode
                    return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
                 }
                 InsertLog "OK"
               }
               default {InsertLog "module type $m does not require or support ADC Calibration"}
            }
         }

        global MIDAS_TapeServer_Exists
        if {[info exists MIDAS_TapeServer_Exists]} {
           InsertLog "Load Data Storage Service"
puts  "Load Data Storage Service"
           namespace eval ::TapeService {   ;#  preload TapeService
              global env

              set started 0
              source [file join $env(MIDASBASE) TclHttpd tcl Common common.tcl]
              set f [file join $env(MIDASBASE) TclHttpd Html TapeService TapeService.tcl]
              set z [catch {source $f} m]
              if {$z != 0} {puts "$f > $m"}
           }
           InsertLog "Start Data Storage Service"
#           set rc [catch {Inform TapeService do_update} m]
   set rc 0
   set m ""
           InsertLog "Tape Server returns $rc $m"
           if {$rc != 0} {
              set rc $errorCode
              return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
           }
           InsertLog "OK"
        }

     InsertLog "initialise complete"
puts "initialise complete"

    }


   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

		    HELP     {
			variable HelpTopic
			set HelpTopic $vl
			do_help
		    }

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   EXPERT   {$vl}
                   Initialise {do_Initialise}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
     }

}   ;# end of if {$started == 0}




