

puts "loading sys.DT5780.tcl"

variable registerlist

lappend registerlist [list NetVar.DT5780_NumSamples  "-n DT5780_NumSamples -t int"]
lappend registerlist [list NetVar.DT5780_VMERetries  "-n DT5780_VMERetries -t int"]
lappend registerlist [list NetVar.DT5780_BERREnable  "-n DT5780_BERREnable -t int"]
lappend registerlist [list NetVar.DT5780_VMEBufSize  "-n DT5780_VMEBufSize -t int"]

variable NumChans 2
variable DT5780_Base 64

proc Set_DT5780_Options {} {
    variable Options
    variable DT5780_Base

puts "Set_DT5780_Options"

    load_Options

   if {![info exists Options(DT5780_MaxEvtsPerBuf)]}         {set Options(DT5780_MaxEvtsPerBuf) 1}
   if {![info exists Options(DT5780_MaxBLT)]}                {set Options(DT5780_MaxBLT) 1}
   if {![info exists Options(DT5780_MemBufSize)]}            {set Options(DT5780_MemBufSize) 1024}
   if {![info exists Options(DT5780_VMEBufSize)]}            {set Options(DT5780_VMEBufSize) 16384}

   if {![info exists Options(DT5780_Hist_TraceA.Enable)]}    {set Options(DT5780_Hist_TraceA.Enable) 0}
   if {![info exists Options(DT5780_Hist_TraceB.Enable)]}    {set Options(DT5780_Hist_TraceB.Enable) 0}
   if {![info exists Options(DT5780_Hist_Energy.Enable)]}    {set Options(DT5780_Hist_Energy.Enable) 1}
   if {![info exists Options(DT5780_Hist_DVP0.Enable)]}      {set Options(DT5780_Hist_DVP0.Enable) 0}
   if {![info exists Options(DT5780_Hist_TimeH.Enable)]}     {set Options(DT5780_Hist_TimeH.Enable) 0}
   if {![info exists Options(DT5780_Hist_TimeL.Enable)]}     {set Options(DT5780_Hist_TimeL.Enable) 0}
   if {![info exists Options(DT5780_Hist_Wave.Enable)]}      {set Options(DT5780_Hist_Wave.Enable) 0}
   if {![info exists Options(DT5780_Hist_Wave.channels)]}  {set Options(DT5780_Hist_Wave.channels) 512}
   if {![info exists Options(DT5780_Hist_Wave.offset)]}    {set Options(DT5780_Hist_Wave.offset) 0}
   if {![info exists Options(DT5780_Hist_Wave.shift)]}     {set Options(DT5780_Hist_Wave.shift) 0}
   if {![info exists Options(DT5780_Hist_Energy.channels)]}  {set Options(DT5780_Hist_Energy.channels) 32768}
   if {![info exists Options(DT5780_Hist_Energy.offset)]}    {set Options(DT5780_Hist_Energy.offset) 0}
   if {![info exists Options(DT5780_Hist_Energy.shift)]}     {set Options(DT5780_Hist_Energy.shift) 0}
   if {![info exists Options(DT5780_Hist_TimeH.channels)]}   {set Options(DT5780_Hist_TimeH.channels) 65536}
   if {![info exists Options(DT5780_Hist_TimeH.offset)]}     {set Options(DT5780_Hist_TimeH.offset) 0}
   if {![info exists Options(DT5780_Hist_TimeH.shift)]}      {set Options(DT5780_Hist_TimeH.shift) 0}
   if {![info exists Options(DT5780_Hist_TimeL.channels)]}   {set Options(DT5780_Hist_TimeL.channels) 65536}
   if {![info exists Options(DT5780_Hist_TimeL.offset)]}     {set Options(DT5780_Hist_TimeL.offset) 0}
   if {![info exists Options(DT5780_Hist_TimeL.shift)]}      {set Options(DT5780_Hist_TimeL.shift) 0}
   if {![info exists Options(DT5780_GroupBase)]}             {set Options(DT5780_GroupBase) $DT5780_Base}
   set DT5780_Base  $Options(DT5780_GroupBase)

    update_Options
}

proc DT5780_Configure {} {
    variable Options
    variable NumChans

#      set z [catch {ReadVMERegister dt5780#1.BoardInfo} m]
#      if {$z==0} then {set NumChans [expr ($m >> 16) & 255]}

puts "DT5780_Configure: channels=$NumChans"

    set VME_BUFFER_SIZE [ReadNetVar NetVar.DT5780_VMEBufSize]
    set Options(DT5780_VMEBufSize) $VME_BUFFER_SIZE

      update_Options

           switch $Options(DT5780_MemBufSize) {
              65536 {set BUFF_ORG 2; set BUFF_NUM 4}
              32768 {set BUFF_ORG 3; set BUFF_NUM 8}
              16384 {set BUFF_ORG 4; set BUFF_NUM 16}
              8192  {set BUFF_ORG 5; set BUFF_NUM 32}
              4096  {set BUFF_ORG 6; set BUFF_NUM 64}
              2048  {set BUFF_ORG 7; set BUFF_NUM 128}
              1024  {set BUFF_ORG 8; set BUFF_NUM 256}
              512   {set BUFF_ORG 9; set BUFF_NUM 512}
              256   {set BUFF_ORG 10; set BUFF_NUM 1024}
              default {set BUFF_ORG 8; set BUFF_NUM 512}
           }

      set Buf_Size [expr $Options(DT5780_MemBufSize) / $BUFF_NUM]  ;# buffer in 32 bit words

      set z [catch {ReadVMERegisterAttr dt5780#1.VMEStatus} m]
      if {$z==0} then {

           set z [catch {WriteVMERegister dt5780#1.VMEControl 16} m];  #  force BERR option

           set z [catch {ReadVMERegister dt5780#1.CustomSize} SIZE];
           if {$SIZE <= 0} {set SIZE 32}
           WriteNetVar NetVar.DT5780_NumSamples [expr $SIZE * 2]

           set NUM [expr (($Options(DT5780_MemBufSize) - 2) * 2) / $SIZE]
           if {$NUM > $Options(DT5780_MaxEvtsPerBuf)} {set NUM $Options(DT5780_MaxEvtsPerBuf)}

           set z [catch {ReadVMERegister dt5780#1.VMEControl} BERR]  ;#  enable BERR to finish a VME block transfer
           if {$BERR < 0} {set BERR 0}
           WriteNetVar NetVar.DT5780_BERREnable [expr ($BERR >> 4) & 1]

puts "DT5780 Output buffers $BUFF_NUM  @ $Options(DT5780_MemBufSize) 32 bit words"
puts "Waveform [expr $SIZE * 2] samples"
puts "$NumChans channels; $NUM events/buffer"

           set osize [expr (($SIZE + 2) * $NUM) + 2]
puts "DT5780 buffer size used $osize words out of max $Options(DT5780_MemBufSize)"

           if {$osize > $Options(DT5780_MemBufSize)} {
              puts "Number of samples or Events per buffer is too big\n\
                 $osize > $Options(DT5780_MemBufSize) - this is not permitted\n\
                 correct options and try again"
              return
           }

           set BLT [expr $VME_BUFFER_SIZE / (($osize * $NumChans) + 4)]
           if {$BLT > $Options(DT5780_MaxBLT)} {set BLT $Options(DT5780_MaxBLT)}

puts "BLT Event Number = $BLT"
           set isize [expr (($osize * $NumChans) + 4) * $BLT]
puts "Data Acq Input buffer size used $isize words out of max $VME_BUFFER_SIZE"

puts "DT5780_Configure $BERR $SIZE $BUFF_ORG $NUM"

           WriteVMERegisters dt5780#*.VMEControl $BERR     ;# set all modules to same setting
           WriteVMERegisters dt5780#*.CustomSize $SIZE     ;# set all modules to same setting
           WriteVMERegisters dt5780#*.BufferOrg $BUFF_ORG
           WriteVMERegisters dt5780#*.EvtsPerBuf $NUM
           WriteVMERegisters dt5780#*.BLTEventNum $BLT     ;# set all modules to same setting
      }

puts "DT5780_Configure finished"

}

proc DT5780_DAQ-go {} {puts "DT5780_DAQ-go"

   set maxmodule 0
   for {set i 1} {$i <= 16} {incr i} {
      set z [catch {ReadVMERegisterAttr dt5780#$i.VMEStatus} m]
      if {$z!=0} then {break}
      incr maxmodule
   }

   for {set i 1} {$i <= $maxmodule} {incr i} {

      set z [catch {ReadVMERegister dt5780#$i.AcqControl} m]
      if {$z == 0} {WriteVMERegister dt5780#$i.AcqControl [expr ($m & 0xfb) + 4]}

   }
}

proc DT5780_DAQ-halt {} {puts "DT5780_DAQ-halt"

   set maxmodule 0
   for {set i 1} {$i <= 16} {incr i} {
      set z [catch {ReadVMERegisterAttr dt5780#$i.VMEStatus} m]
      if {$z!=0} then {break}
      incr maxmodule
   }

   for {set i 1} {$i <= $maxmodule} {incr i} {

      set z [catch {ReadVMERegister dt5780#$i.AcqControl} m]
      if {$z == 0} {WriteVMERegister dt5780#$i.AcqControl [expr ($m & 0xfb)]}

   }

   for {set i 1} {$i <= $maxmodule} {incr i} {

      set z [catch {WriteVMERegister dt5780#$i.Clear 0} m]

   }
}

proc DT5780_DAQ-setup {} {puts "DT5780_DAQ-setup"

     DT5780_Configure
}

proc DT5780_DAQ-flush {} {}

proc DT5780_DAQ-reset {} {}

proc define_DT5780_config {} {puts "define_DT5780_config"
    variable Options
    variable DT5780_Base

   set maxmodule 0
   for {set i 1} {$i <= 16} {incr i} {
      set z [catch {ReadVMERegisterAttr dt5780#$i.VMEStatus} m]
      if {$z!=0} then {break}
      incr maxmodule
   }

   if {$maxmodule > 0} then {DefineConfig "17243 0 [format "0x%x" $DT5780_Base]"}

   for {set i 1} {$i <= $maxmodule} {incr i} {

      set z [catch {ReadVMERegisterAttr dt5780#$i.Output_Buffer} m]
      if {$z!=0} then {
          puts "Attempting to locate register dt5780#$i.Output_Buffer"
          error $m
      }

      DefineConfig "17243 $i [string range [first $m] 2 end]"
   }
}

proc create_DT5780_spectra {} {
    variable DT5780_Base
    variable NumChans
    variable Options 

puts "create_DT5780_spectra"

   set maxmodule 0
   for {set i 1} {$i <= 16} {incr i} {
      set z [catch {ReadVMERegisterAttr dt5780#$i.VMEStatus} m]
      if {$z!=0} then {break}
      incr maxmodule
   }

   set UseGroup [ReadNetVar NetVar.UseGroup]

   for {set i 1} {$i <= $maxmodule} {incr i} {

     if {$Options(DT5780_Hist_Energy.Enable) == 1} {

        for {set j 0} {$j < $NumChans} {incr j} {   

#    histograms for the computed energy

           set spectrumname dt5780#$i.E[set j]
           set z [catch {CreateSpectrum1D $spectrumname $Options(DT5780_Hist_Energy.channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              puts "Attempting to create spectrum $spectrumname"
              error $m
           } else {

               if {$UseGroup == 0} {
                   set group [expr ($i - 1) + $DT5780_Base]
                   set item [expr $j + (0 << 3)]
               } else {
                   set group [expr (($i - 1) * $NumChans) + $j + $DT5780_Base]
                   set item 0
               }
               map_spectrum  "$spectrumname $group $item $Options(DT5780_Hist_Energy.offset) $Options(DT5780_Hist_Energy.shift)"

           }
        }
     }


     if {$Options(DT5780_Hist_TimeH.Enable) == 1} {

        for {set j 0} {$j < $NumChans} {incr j} {   

#    histograms for the time (MSW)

           set spectrumname dt5780#$i.TH[set j]
           set z [catch {CreateSpectrum1D $spectrumname $Options(DT5780_Hist_TimeH.channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              puts "Attempting to create spectrum $spectrumname"
              error $m
           } else {
               if {$UseGroup == 0} {
                   set group [expr ($i - 1) + $DT5780_Base]
                   set item [expr $j + (2 << 3)]
               } else {
                   set group [expr (($i - 1) * $NumChans) + $j + $DT5780_Base]
                   set item 2
               }
              map_spectrum  "$spectrumname $group $item $Options(DT5780_Hist_TimeH.offset) $Options(DT5780_Hist_TimeH.shift)"
           }
        }
     }

    if {$Options(DT5780_Hist_TimeL.Enable) == 1} {

        for {set j 0} {$j < $NumChans} {incr j} {   

#    histograms for the time (LSW)

           set spectrumname dt5780#$i.TL[set j]
           set z [catch {CreateSpectrum1D $spectrumname $Options(DT5780_Hist_TimeL.channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              puts "Attempting to create spectrum $spectrumname"
              error $m
           } else {
               if {$UseGroup == 0} {
                   set group [expr ($i - 1) + $DT5780_Base]
                   set item [expr $j + (3 << 3)]
               } else {
                   set group [expr (($i - 1) * $NumChans) + $j + $DT5780_Base]
                   set item 3
               }
              map_spectrum  "$spectrumname $group $item $Options(DT5780_Hist_TimeL.offset) $Options(DT5780_Hist_TimeL.shift)"
           }
        }
     }

     if {$Options(DT5780_Hist_Wave.Enable) == 1} {

        for {set j 0} {$j < $NumChans} {incr j} {   

#    histograms for the waveform

           set spectrumname dt5780#$i.W[set j]
           set z [catch {CreateSpectrum1D $spectrumname $Options(DT5780_Hist_Wave.channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              puts "Attempting to create spectrum $spectrumname"
              error $m
           } else {
              set group  [expr (($i-1) * $NumChans) + $j + 256  + $DT5780_Base] 
              set item 0
              map_spectrum  "$spectrumname $group $item $Options(DT5780_Hist_Wave.offset) $Options(DT5780_Hist_Wave.shift)"
           }
        }
     }

     if {$Options(DT5780_Hist_TraceA.Enable) == 1} {

        for {set j 0} {$j < $NumChans} {incr j} {   

#    histograms for the data trace A

           set spectrumname dt5780#$i.ChA[set j]
           set z [catch {CreateSpectrum1D $spectrumname $Options(DT5780_Hist_Wave.channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              puts "Attempting to create spectrum $spectrumname"
              error $m
           } else {
              set group  [expr (($i-1) * $NumChans) + $j + 384  + $DT5780_Base] 
              set item 0
              map_spectrum  "$spectrumname $group $item $Options(DT5780_Hist_Wave.offset) $Options(DT5780_Hist_Wave.shift)"
           }
        }
     }

     if {$Options(DT5780_Hist_TraceB.Enable) == 1} {

        for {set j 0} {$j < $NumChans} {incr j} {   

#    histograms for the data trace B

           set spectrumname dt5780#$i.ChB[set j]
           set z [catch {CreateSpectrum1D $spectrumname $Options(DT5780_Hist_Wave.channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              puts "Attempting to create spectrum $spectrumname"
              error $m
           } else {
              set group  [expr (($i-1) * $NumChans) + $j + 384  + $DT5780_Base] 
              set item 1
              map_spectrum  "$spectrumname $group $item $Options(DT5780_Hist_Wave.offset) $Options(DT5780_Hist_Wave.shift)"
           }
        }
     }

     if {$Options(DT5780_Hist_DVP0.Enable) == 1} {

        for {set j 0} {$j < $NumChans} {incr j} {   

#    histograms for the digital virtual probe 0

           set spectrumname dt5780#$i.DVP0[set j]
           set z [catch {CreateSpectrum1D $spectrumname $Options(DT5780_Hist_Wave.channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              puts "Attempting to create spectrum $spectrumname"
              error $m
           } else {
              set group  [expr (($i-1) * $NumChans) + $j + 384  + $DT5780_Base] 
              set item 2
              map_spectrum  "$spectrumname $group $item $Options(DT5780_Hist_Wave.offset) $Options(DT5780_Hist_Wave.shift)"
           }
        }
     }

   }
}

