

puts "loading sys.V1495V2.tcl"


variable registerlist
lappend registerlist [list NetVar.V1495V2_UseCtrl  "-n V1495V2_UseCtrl -t int"]

variable V1495V2_Base 4


proc Set_V1495V2_Options {} {puts "Set_V1495V2_Options"
    variable Options
    variable V1495V2_Base

    load_Options

   if {![info exists Options(V1495V2_Base)]} {set Options(V1495V2_Base) $V1495V2_Base}

    update_Options
}

proc V1495V2_Configure {} {puts "V1495V2_Configure"}

proc V1495V2_DAQ-go {} {puts "V1495V2_DAQ-go"
#    WriteVMERegister V1495V2#1.FT_RUN 1    ;#  enable acquisition   in sys.tcl
#    WriteVMERegister V1495V2#1.MIS4 3
}

proc V1495V2_DAQ-halt {} {puts "V1495V2_DAQ-halt"
#    WriteVMERegister V1495V2#1.FT_RUN 0     ;#  disable acquisition also in sys.tcl
#    WriteVMERegister V1495V2#1.MIS4 0
}

proc V1495V2_DAQ-setup {} {puts "V1495V2_DAQ-setup"

#     WriteVMERegister V1495V2#1.FT_RUN 0
#     V1495V2_Configure
}

proc V1495V2_DAQ-flush {} {puts "V1495V2_DAQ-flush"}

proc V1495V2_DAQ-reset {} {puts "V1495V2_DAQ-reset"

#     WriteVMERegister V1495V2#1.FT_RUN 0
}

proc define_V1495V2_config {} {puts "define_V1495V2_config"
   variable Options

   set maxmodule 0
   for {set i 1} {$i <= 16} {incr i} {
      set z [catch {ReadVMERegisterAttr v1495v2#$i.VMEStatus} m]
      if {$z!=0} then {break}
      incr maxmodule
   }

   if {$maxmodule > 0} then {set Options(Use1495DPP) 0; set Options(Use1495) 0; set Options(Use1495V2) 1} else {set Options(Use1495V2) 0}

   if {$maxmodule > 0} then {DefineConfig "14952 0 [format "0x%x" $Options(V1495V2_Base)]"}

   for {set i 1} {$i <= $maxmodule} {incr i} {

      set z [catch {ReadVMERegisterAttr v1495v2#$i.DataBuffer} m]
      if {$z!=0} then {
          puts "Attempting to locate register V1495V2#$i.DataBuffer"
          error $m
      }

      DefineConfig "14952 $i [string range [first $m] 2 end]"
   }

puts "Use1495V2=$Options(Use1495V2); V1495V2_Base=$Options(V1495V2_Base)"

}


proc create_V1495V2_spectra {} {
    variable V1495V2_Base

puts "create_V1495V2_spectra"

   set maxmodule 0
   for {set i 1} {$i <= 16} {incr i} {
      set z [catch {ReadVMERegisterAttr V1495V2#$i.VMEStatus} m]
      if {$z!=0} then {break}
      incr maxmodule
   }

   for {set i 1} {$i <= $maxmodule} {incr i} {

#     if {$Options(V1495V2_Hist.Enable) == 1} {

#    so item rate available in Stat & Rate histograms

           set spectrumname V1495V2#$i.data
           set z [catch {CreateSpectrum1D $spectrumname 100} m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              puts "Attempting to create spectrum $spectrumname"
              error $m
           } else {

               set group [expr ($i - 1) + $V1495V2_Base]
               set item 0
               map_spectrum  "$spectrumname $group $item 0 0"

           }
#     }

   }

}




