

puts "loading sys.V1724PHA.tcl"

variable registerlist

lappend registerlist [list NetVar.V1724PHA_NumSamples  "-n V1724PHA_NumSamples -t int"]
lappend registerlist [list NetVar.V1724PHA_VMERetries  "-n V1724PHA_VMERetries -t int"]
lappend registerlist [list NetVar.V1724PHA_BERREnable  "-n V1724PHA_BERREnable -t int"]
lappend registerlist [list NetVar.V1724PHA_VMEBufSize  "-n V1724PHA_VMEBufSize -t int"]

variable NumChans 8
variable V1724PHA_Base 32

proc Set_V1724PHA_Options {} {
    variable Options
    variable V1724PHA_Base

puts "Set_V1724PHA_Options"

    load_Options

   if {![info exists Options(V1724PHA_MaxEvtsPerBuf)]}         {set Options(V1724PHA_MaxEvtsPerBuf) 1}
   if {![info exists Options(V1724PHA_MaxBLT)]}                {set Options(V1724PHA_MaxBLT) 1}
   if {![info exists Options(V1724PHA_MemBufSize)]}            {set Options(V1724PHA_MemBufSize) 1024}
   if {![info exists Options(V1724PHA_VMEBufSize)]}            {set Options(V1724PHA_VMEBufSize) 16384}

   if {![info exists Options(V1724PHA_Hist_TraceA.Enable)]}    {set Options(V1724PHA_Hist_TraceA.Enable) 0}
   if {![info exists Options(V1724PHA_Hist_TraceB.Enable)]}    {set Options(V1724PHA_Hist_TraceB.Enable) 0}
   if {![info exists Options(V1724PHA_Hist_Energy.Enable)]}    {set Options(V1724PHA_Hist_Energy.Enable) 1}
   if {![info exists Options(V1724PHA_Hist_DVP0.Enable)]}      {set Options(V1724PHA_Hist_DVP0.Enable) 0}
   if {![info exists Options(V1724PHA_Hist_TimeH.Enable)]}     {set Options(V1724PHA_Hist_TimeH.Enable) 0}
   if {![info exists Options(V1724PHA_Hist_TimeL.Enable)]}     {set Options(V1724PHA_Hist_TimeL.Enable) 0}
   if {![info exists Options(V1724PHA_Hist_Wave.Enable)]}      {set Options(V1724PHA_Hist_Wave.Enable) 0}
   if {![info exists Options(V1724PHA_Hist_Wave.channels)]}  {set Options(V1724PHA_Hist_Wave.channels) 512}
   if {![info exists Options(V1724PHA_Hist_Wave.offset)]}    {set Options(V1724PHA_Hist_Wave.offset) 0}
   if {![info exists Options(V1724PHA_Hist_Wave.shift)]}     {set Options(V1724PHA_Hist_Wave.shift) 0}
   if {![info exists Options(V1724PHA_Hist_Energy.channels)]}  {set Options(V1724PHA_Hist_Energy.channels) 32768}
   if {![info exists Options(V1724PHA_Hist_Energy.offset)]}    {set Options(V1724PHA_Hist_Energy.offset) 0}
   if {![info exists Options(V1724PHA_Hist_Energy.shift)]}     {set Options(V1724PHA_Hist_Energy.shift) 0}
   if {![info exists Options(V1724PHA_Hist_TimeH.channels)]}   {set Options(V1724PHA_Hist_TimeH.channels) 65536}
   if {![info exists Options(V1724PHA_Hist_TimeH.offset)]}     {set Options(V1724PHA_Hist_TimeH.offset) 0}
   if {![info exists Options(V1724PHA_Hist_TimeH.shift)]}      {set Options(V1724PHA_Hist_TimeH.shift) 0}
   if {![info exists Options(V1724PHA_Hist_TimeL.channels)]}   {set Options(V1724PHA_Hist_TimeL.channels) 65536}
   if {![info exists Options(V1724PHA_Hist_TimeL.offset)]}     {set Options(V1724PHA_Hist_TimeL.offset) 0}
   if {![info exists Options(V1724PHA_Hist_TimeL.shift)]}      {set Options(V1724PHA_Hist_TimeL.shift) 0}
   if {![info exists Options(V1724PHA_GroupBase)]}             {set Options(V1724PHA_GroupBase) $V1724PHA_Base}
   set V1724PHA_Base  $Options(V1724PHA_GroupBase)

    update_Options
}

proc V1724PHA_Configure {} {
    variable Options
    variable NumChans
    variable V1724PHA_Base

      set z [catch {ReadVMERegister v1724pha#1.BoardInfo} m]
      if {$z==0} then {set NumChans [expr ($m >> 16) & 255]}

puts "V1724PHA_Configure: channels=$NumChans; GroupBase=$V1724PHA_Base"

    set VME_BUFFER_SIZE [ReadNetVar NetVar.V1724PHA_VMEBufSize]
    set Options(V1724PHA_VMEBufSize) $VME_BUFFER_SIZE

      update_Options

           switch $Options(V1724PHA_MemBufSize) {
              65536 {set BUFF_ORG 2; set BUFF_NUM 4}
              32768 {set BUFF_ORG 3; set BUFF_NUM 8}
              16384 {set BUFF_ORG 4; set BUFF_NUM 16}
              8192  {set BUFF_ORG 5; set BUFF_NUM 32}
              4096  {set BUFF_ORG 6; set BUFF_NUM 64}
              2048  {set BUFF_ORG 7; set BUFF_NUM 128}
              1024  {set BUFF_ORG 8; set BUFF_NUM 256}
              512   {set BUFF_ORG 9; set BUFF_NUM 512}
              256   {set BUFF_ORG 10; set BUFF_NUM 1024}
              default {set BUFF_ORG 8; set BUFF_NUM 256}
           }

      set Buf_Size [expr $Options(V1724PHA_MemBufSize) / $BUFF_NUM]  ;# buffer in 32 bit words

      set z [catch {ReadVMERegisterAttr v1724pha#1.VMEStatus} m]
      if {$z==0} then {

           set z [catch {WriteVMERegister v1724pha#1.VMEControl 16} m];  #  force BERR option

           set z [catch {ReadVMERegister v1724pha#1.CustomSize} SIZE];
           if {$SIZE <= 0} {set SIZE 32}
           WriteNetVar NetVar.V1724PHA_NumSamples [expr $SIZE * 2]

           set NUM [expr (($Options(V1724PHA_MemBufSize) - 2) * 2) / $SIZE]
           if {$NUM > $Options(V1724PHA_MaxEvtsPerBuf)} {set NUM $Options(V1724PHA_MaxEvtsPerBuf)}

           set z [catch {ReadVMERegister v1724pha#1.VMEControl} BERR]  ;#  enable BERR to finish a VME block transfer
           if {$BERR < 0} {set BERR 0}
           WriteNetVar NetVar.V1724PHA_BERREnable [expr ($BERR >> 4) & 1]

puts "V1724PHA Output buffers $BUFF_NUM  @ $Buf_Size 32 bit words"
puts "Waveform [expr $SIZE * 2] samples"
puts "$NumChans channels; $NUM events/buffer"

           set osize [expr (($SIZE + 2) * $NUM) + 2]
puts "V1724PHA buffer size used $osize words out of max $Options(V1724PHA_MemBufSize)"

           if {$osize > $Options(V1724PHA_MemBufSize)} {
              puts "Number of samples or Events per buffer is too big\n\
                 $osize > $Options(V1724PHA_MemBufSize) - this is not permitted\n\
                 correct options and try again"
              return
           }

           set BLT [expr $VME_BUFFER_SIZE / (($osize * $NumChans) + 4)]
           if {$BLT > $Options(V1724PHA_MaxBLT)} {set BLT $Options(V1724PHA_MaxBLT)}

puts "BLT Event Number = $BLT"
           set isize [expr (($osize * $NumChans) + 4) * $BLT]
puts "Data Acq Input buffer size used $isize words out of max $VME_BUFFER_SIZE"

puts "V1724PHA_Configure $BERR $SIZE $BUFF_ORG $NUM $BLT"

           WriteVMERegisters v1724pha#*.VMEControl $BERR     ;# set all modules to same setting
           WriteVMERegisters v1724pha#*.CustomSize $SIZE     ;# set all modules to same setting
           WriteVMERegisters v1724pha#*.BufferOrg $BUFF_ORG
           WriteVMERegisters v1724pha#*.EvtsPerBuf $NUM
           WriteVMERegisters v1724pha#*.BLTEventNum $BLT     ;# set all modules to same setting
      }

puts "V1724PHA_Configure finished"

}

proc V1724PHA_DAQ-go {} {puts "V1724PHA_DAQ-go"

   set maxmodule 0
   for {set i 1} {$i <= 16} {incr i} {
      set z [catch {ReadVMERegisterAttr v1724pha#$i.VMEStatus} m]
      if {$z!=0} then {break}
      incr maxmodule
   }

   for {set i 1} {$i <= $maxmodule} {incr i} {

      set z [catch {ReadVMERegister v1724pha#$i.AcqControl} m]
      if {$z == 0} {WriteVMERegister v1724pha#$i.AcqControl [expr ($m & 0xfb) + 4]}

   }
}

proc V1724PHA_DAQ-halt {} {puts "V1724PHA_DAQ-halt"

   set maxmodule 0
   for {set i 1} {$i <= 16} {incr i} {
      set z [catch {ReadVMERegisterAttr v1724pha#$i.VMEStatus} m]
      if {$z!=0} then {break}
      incr maxmodule
   }

   for {set i 1} {$i <= $maxmodule} {incr i} {

      set z [catch {ReadVMERegister v1724pha#$i.AcqControl} m]
      if {$z == 0} {WriteVMERegister v1724pha#$i.AcqControl [expr ($m & 0xfb)]}

   }

   for {set i 1} {$i <= $maxmodule} {incr i} {

      set z [catch {WriteVMERegister v1724pha#$i.Clear 0} m]

   }
}

proc V1724PHA_DAQ-setup {} {puts "V1724PHA_DAQ-setup"

   set maxmodule 0
   for {set i 1} {$i <= 16} {incr i} {
      set z [catch {ReadVMERegisterAttr v1724pha#$i.VMEStatus} m]
      if {$z!=0} then {break}
      incr maxmodule
   }
   if {$maxmodule == 0} {return}

     V1724PHA_Configure
}

proc V1724PHA_DAQ-flush {} {}

proc V1724PHA_DAQ-reset {} {}

proc Dump_Raw_VME_Data_V1724PHA {data} {

        foreach word $data {
           if {[string range $word 0 1] != "0x"} then {set word 0x$word}
           if {$word == 0xaa5555aa} then {
               append info "$word - end of dump\n"
               break
           }
           if {$word == 0x55aaaa55} then {
               append info "$word - end of event\n"
               continue
           }
           append info "$word "
        }

        append info "\n"

   return $info
}

proc define_V1724PHA_config {} {puts "define_V1724PHA_config"
    variable Options
    variable V1724PHA_Base

   set maxmodule 0
   for {set i 1} {$i <= 16} {incr i} {
      set z [catch {ReadVMERegisterAttr v1724pha#$i.VMEStatus} m]
      if {$z!=0} then {puts "$m"; break}
      incr maxmodule
   }

   if {$maxmodule > 0} then {DefineConfig "17241 0 [format "0x%x" $V1724PHA_Base]"}

   for {set i 1} {$i <= $maxmodule} {incr i} {

      set z [catch {ReadVMERegisterAttr v1724pha#$i.Output_Buffer} m]
      if {$z!=0} then {
          puts "Attempting to locate register v1724pha#$i.Output_Buffer"
          puts "$m"
      }

      DefineConfig "17241 $i [string range [first $m] 2 end]"
   }
}

proc create_V1724PHA_spectra {} {
    variable V1724PHA_Base
    variable NumChans
    variable Options 

puts "create_V1724PHA_spectra"

   set maxmodule 0
   for {set i 1} {$i <= 16} {incr i} {
      set z [catch {ReadVMERegisterAttr v1724pha#$i.VMEStatus} m]
      if {$z!=0} then {break}
      incr maxmodule
   }

   set UseGroup [ReadNetVar NetVar.UseGroup]

   for {set i 1} {$i <= $maxmodule} {incr i} {

     if {$Options(V1724PHA_Hist_Energy.Enable) == 1} {

        for {set j 0} {$j < $NumChans} {incr j} {   

#    histograms for the computed energy

           set spectrumname v1724pha#$i.E[set j]
           set z [catch {CreateSpectrum1D $spectrumname $Options(V1724PHA_Hist_Energy.channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              puts "Attempting to create spectrum $spectrumname"
              puts "$m"
           } else {

               if {$UseGroup == 0} {
                   set group [expr ($i - 1) + $V1724PHA_Base]
                   set item [expr $j + (0 << 3)]
               } else {
                   set group [expr (($i - 1) * $NumChans) + $j + $V1724PHA_Base]
                   set item 0
               }
               map_spectrum  "$spectrumname $group $item $Options(V1724PHA_Hist_Energy.offset) $Options(V1724PHA_Hist_Energy.shift)"

           }
        }
     }


     if {$Options(V1724PHA_Hist_TimeH.Enable) == 1} {

        for {set j 0} {$j < $NumChans} {incr j} {   

#    histograms for the time (MSW)

           set spectrumname v1724pha#$i.TH[set j]
           set z [catch {CreateSpectrum1D $spectrumname $Options(V1724PHA_Hist_TimeH.channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              puts "Attempting to create spectrum $spectrumname"
              puts "$m"
           } else {
               if {$UseGroup == 0} {
                   set group [expr ($i - 1) + $V1724PHA_Base]
                   set item [expr $j + (2 << 3)]
               } else {
                   set group [expr (($i - 1) * $NumChans) + $j + $V1724PHA_Base]
                   set item 2
               }
              map_spectrum  "$spectrumname $group $item $Options(V1724PHA_Hist_TimeH.offset) $Options(V1724PHA_Hist_TimeH.shift)"
           }
        }
     }

    if {$Options(V1724PHA_Hist_TimeL.Enable) == 1} {

        for {set j 0} {$j < $NumChans} {incr j} {   

#    histograms for the time (LSW)

           set spectrumname v1724pha#$i.TL[set j]
           set z [catch {CreateSpectrum1D $spectrumname $Options(V1724PHA_Hist_TimeL.channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              puts "Attempting to create spectrum $spectrumname"
              puts "$m"
           } else {
               if {$UseGroup == 0} {
                   set group [expr ($i - 1) + $V1724PHA_Base]
                   set item [expr $j + (3 << 3)]
               } else {
                   set group [expr (($i - 1) * $NumChans) + $j + $V1724PHA_Base]
                   set item 3
               }
              map_spectrum  "$spectrumname $group $item $Options(V1724PHA_Hist_TimeL.offset) $Options(V1724PHA_Hist_TimeL.shift)"
           }
        }
     }

     if {$Options(V1724PHA_Hist_Wave.Enable) == 1} {

        for {set j 0} {$j < $NumChans} {incr j} {   

#    histograms for the waveform

           set spectrumname v1724pha#$i.W[set j]
           set z [catch {CreateSpectrum1D $spectrumname $Options(V1724PHA_Hist_Wave.channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              puts "Attempting to create spectrum $spectrumname"
              puts "$m"
           } else {
              set group  [expr (($i-1) * $NumChans) + $j + 256  + $V1724PHA_Base] 
              set item 0
              map_spectrum  "$spectrumname $group $item $Options(V1724PHA_Hist_Wave.offset) $Options(V1724PHA_Hist_Wave.shift)"
           }
        }
     }

     if {$Options(V1724PHA_Hist_TraceA.Enable) == 1} {

        for {set j 0} {$j < $NumChans} {incr j} {   

#    histograms for the data trace A

           set spectrumname v1724pha#$i.ChA[set j]
           set z [catch {CreateSpectrum1D $spectrumname $Options(V1724PHA_Hist_Wave.channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              puts "Attempting to create spectrum $spectrumname"
              puts "$m"
           } else {
              set group  [expr (($i-1) * $NumChans) + $j + 384  + $V1724PHA_Base] 
              set item 0
              map_spectrum  "$spectrumname $group $item $Options(V1724PHA_Hist_Wave.offset) $Options(V1724PHA_Hist_Wave.shift)"
           }
        }
     }

     if {$Options(V1724PHA_Hist_TraceB.Enable) == 1} {

        for {set j 0} {$j < $NumChans} {incr j} {   

#    histograms for the data trace B

           set spectrumname v1724pha#$i.ChB[set j]
           set z [catch {CreateSpectrum1D $spectrumname $Options(V1724PHA_Hist_Wave.channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              puts "Attempting to create spectrum $spectrumname"
              puts "$m"
           } else {
              set group  [expr (($i-1) * $NumChans) + $j + 384  + $V1724PHA_Base] 
              set item 1
              map_spectrum  "$spectrumname $group $item $Options(V1724PHA_Hist_Wave.offset) $Options(V1724PHA_Hist_Wave.shift)"
           }
        }
     }

     if {$Options(V1724PHA_Hist_DVP0.Enable) == 1} {

        for {set j 0} {$j < $NumChans} {incr j} {   

#    histograms for the digital virtual probe 0

           set spectrumname v1724pha#$i.DVP0[set j]
           set z [catch {CreateSpectrum1D $spectrumname $Options(V1724PHA_Hist_Wave.channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              puts "Attempting to create spectrum $spectrumname"
              puts "$m"
           } else {
              set group  [expr (($i-1) * $NumChans) + $j + 384  + $V1724PHA_Base] 
              set item 2
              map_spectrum  "$spectrumname $group $item $Options(V1724PHA_Hist_Wave.offset) $Options(V1724PHA_Hist_Wave.shift)"
           }
        }
     }

   }
}

