

puts "loading sys.V1725PHA.tcl"

variable registerlist

lappend registerlist [list NetVar.V1725PHA_NumSamples  "-n V1725PHA_NumSamples -t int"]
lappend registerlist [list NetVar.V1725PHA_VMERetries  "-n V1725PHA_VMERetries -t int"]
lappend registerlist [list NetVar.V1725PHA_BERREnable  "-n V1725PHA_BERREnable -t int"]
lappend registerlist [list NetVar.V1725PHA_VMEBufSize  "-n V1725PHA_VMEBufSize -t int"]

variable NumChans 16
variable V1725PHA_Base 96

proc Set_V1725PHA_Options {} {
    variable Options
    variable V1725PHA_Base

puts "Set_V1725PHA_Options"

    load_Options

   if {![info exists Options(V1725PHA_MaxEvtsPerBuf)]}         {set Options(V1725PHA_MaxEvtsPerBuf) 1}
   if {![info exists Options(V1725PHA_MaxBLT)]}                {set Options(V1725PHA_MaxBLT) 100}
   if {![info exists Options(V1725PHA_MemBufSize)]}            {set Options(V1725PHA_MemBufSize) 1024}
   if {![info exists Options(V1725PHA_VMEBufSize)]}            {set Options(V1725PHA_VMEBufSize) 16384}

   if {![info exists Options(V1725PHA_Hist_TraceA.Enable)]}    {set Options(V1725PHA_Hist_TraceA.Enable) 0}
   if {![info exists Options(V1725PHA_Hist_TraceB.Enable)]}    {set Options(V1725PHA_Hist_TraceB.Enable) 0}
   if {![info exists Options(V1725PHA_Hist_Energy.Enable)]}    {set Options(V1725PHA_Hist_Energy.Enable) 1}
   if {![info exists Options(V1725PHA_Hist_DVP0.Enable)]}      {set Options(V1725PHA_Hist_DVP0.Enable) 0}
   if {![info exists Options(V1725PHA_Hist_BaseLine.Enable)]}  {set Options(V1725PHA_Hist_BaseLine.Enable) 0}
   if {![info exists Options(V1725PHA_Hist_TimeX.Enable)]}     {set Options(V1725PHA_Hist_TimeX.Enable) 0}
   if {![info exists Options(V1725PHA_Hist_TimeH.Enable)]}     {set Options(V1725PHA_Hist_TimeH.Enable) 0}
   if {![info exists Options(V1725PHA_Hist_TimeL.Enable)]}     {set Options(V1725PHA_Hist_TimeL.Enable) 0}
   if {![info exists Options(V1725PHA_Hist_TimeF.Enable)]}     {set Options(V1725PHA_Hist_TimeF.Enable) 1}
   if {![info exists Options(V1725PHA_Hist_Wave.Enable)]}      {set Options(V1725PHA_Hist_Wave.Enable) 0}
   if {![info exists Options(V1725PHA_Hist_Wave.channels)]}    {set Options(V1725PHA_Hist_Wave.channels) 512}
   if {![info exists Options(V1725PHA_Hist_Wave.offset)]}      {set Options(V1725PHA_Hist_Wave.offset) 0}
   if {![info exists Options(V1725PHA_Hist_Wave.shift)]}       {set Options(V1725PHA_Hist_Wave.shift) 0}
   if {![info exists Options(V1725PHA_Hist_Energy.channels)]}  {set Options(V1725PHA_Hist_Energy.channels) 32768}
   if {![info exists Options(V1725PHA_Hist_Energy.offset)]}    {set Options(V1725PHA_Hist_Energy.offset) 0}
   if {![info exists Options(V1725PHA_Hist_Energy.shift)]}     {set Options(V1725PHA_Hist_Energy.shift) 0}
   if {![info exists Options(V1725PHA_Hist_BaseLine.channels)]}  {set Options(V1725PHA_Hist_BaseLine.channels) 65536}
   if {![info exists Options(V1725PHA_Hist_BaseLine.offset)]}    {set Options(V1725PHA_Hist_BaseLine.offset) 0}
   if {![info exists Options(V1725PHA_Hist_BaseLine.shift)]}     {set Options(V1725PHA_Hist_BaseLine.shift) 0}
   if {![info exists Options(V1725PHA_Hist_TimeX.channels)]}   {set Options(V1725PHA_Hist_TimeX.channels) 65536}
   if {![info exists Options(V1725PHA_Hist_TimeX.offset)]}     {set Options(V1725PHA_Hist_TimeX.offset) 0}
   if {![info exists Options(V1725PHA_Hist_TimeX.shift)]}      {set Options(V1725PHA_Hist_TimeX.shift) 0}
   if {![info exists Options(V1725PHA_Hist_TimeH.channels)]}   {set Options(V1725PHA_Hist_TimeH.channels) 65536}
   if {![info exists Options(V1725PHA_Hist_TimeH.offset)]}     {set Options(V1725PHA_Hist_TimeH.offset) 0}
   if {![info exists Options(V1725PHA_Hist_TimeH.shift)]}      {set Options(V1725PHA_Hist_TimeH.shift) 0}
   if {![info exists Options(V1725PHA_Hist_TimeL.channels)]}   {set Options(V1725PHA_Hist_TimeL.channels) 65536}
   if {![info exists Options(V1725PHA_Hist_TimeL.offset)]}     {set Options(V1725PHA_Hist_TimeL.offset) 0}
   if {![info exists Options(V1725PHA_Hist_TimeL.shift)]}      {set Options(V1725PHA_Hist_TimeL.shift) 0}
   if {![info exists Options(V1725PHA_Hist_TimeF.channels)]}   {set Options(V1725PHA_Hist_TimeF.channels) 1024}
   if {![info exists Options(V1725PHA_Hist_TimeF.offset)]}     {set Options(V1725PHA_Hist_TimeF.offset) 0}
   if {![info exists Options(V1725PHA_Hist_TimeF.shift)]}      {set Options(V1725PHA_Hist_TimeF.shift) 0}
   if {![info exists Options(V1725PHA_GroupBase)]}             {set Options(V1725PHA_GroupBase) $V1725PHA_Base}
   set V1725PHA_Base  $Options(V1725PHA_GroupBase)

    update_Options
}

proc V1725PHA_Configure {} {
    variable Options
    variable NumChans
    variable V1725PHA_Base

      set z [catch {ReadVMERegister v1725pha#1.BoardInfo} m]
      if {$z==0} then {set NumChans [expr ($m >> 16) & 255]}

puts "V1725PHA_Configure: channels=$NumChans; GroupBase=$V1725PHA_Base"

    set VME_BUFFER_SIZE [ReadNetVar NetVar.V1725PHA_VMEBufSize]
    set Options(V1725PHA_VMEBufSize) $VME_BUFFER_SIZE

      update_Options

           switch $Options(V1725PHA_MemBufSize) {
              65536 {set BUFF_ORG 2; set BUFF_NUM 4}
              32768 {set BUFF_ORG 3; set BUFF_NUM 8}
              16384 {set BUFF_ORG 4; set BUFF_NUM 16}
              8192  {set BUFF_ORG 5; set BUFF_NUM 32}
              4096  {set BUFF_ORG 6; set BUFF_NUM 64}
              2048  {set BUFF_ORG 7; set BUFF_NUM 128}
              1024  {set BUFF_ORG 8; set BUFF_NUM 256}
              512   {set BUFF_ORG 9; set BUFF_NUM 512}
              256   {set BUFF_ORG 10; set BUFF_NUM 1024}
              default {set BUFF_ORG 8; set BUFF_NUM 256}
           }

      set Buf_Size [expr $Options(V1725PHA_MemBufSize) / $BUFF_NUM]  ;# buffer in 32 bit words

      set z [catch {ReadVMERegisterAttr v1725pha#1.VMEStatus} m]
      if {$z==0} then {

           set z [catch {WriteVMERegister v1725pha#1.VMEControl 16} m];  #  force BERR option

           set z [catch {ReadVMERegister v1725pha#1.Ch0.RecLen} SIZE]
           if {$SIZE <= 0} {set SIZE [expr 256/8]}
           WriteNetVar NetVar.V1725PHA_NumSamples [expr $SIZE*8]

           set WORDS [expr ($SIZE * 8) / 2]   ;# convert to 32 bit words

           set NUM [expr $Options(V1725PHA_MemBufSize) / (8+$WORDS)]  ;# events per buffer
           if {$NUM > $Options(V1725PHA_MaxEvtsPerBuf)} {set NUM $Options(V1725PHA_MaxEvtsPerBuf)}

           set z [catch {ReadVMERegister v1725pha#1.VMEControl} BERR]  ;#  enable BERR to finish a VME block transfer
           if {$BERR < 0} {set BERR 0}
           WriteNetVar NetVar.V1725PHA_BERREnable [expr ($BERR >> 4) & 1]

puts "V1725PHA Output buffers $BUFF_NUM  @ $Buf_Size 32 bit words"
puts "Waveform [expr $SIZE * 8] samples"
puts "$NumChans channels; $NUM events/buffer"

           set osize [expr (($WORDS + 8) * $NUM) + 2]
puts "V1725PHA buffer size used $osize words out of max $Options(V1725PHA_MemBufSize)"

           if {$osize > $Options(V1725PHA_MemBufSize)} {
              puts "Number of samples or Events per buffer is too big\n\
                 $osize > $Options(V1725PHA_MemBufSize) - this is not permitted\n\
                 correct options and try again"
              return
           }

           set BLT [expr $VME_BUFFER_SIZE / (($osize * $NumChans) + 4)]
           if {$BLT > $Options(V1725PHA_MaxBLT)} {set BLT $Options(V1725PHA_MaxBLT)}

puts "BLT Event Number = $BLT"
           set isize [expr (($osize * $NumChans) + 4) * $BLT]
puts "Data Acq Input buffer size used $isize words out of max $VME_BUFFER_SIZE"

puts "V1725PHA_Configure $BERR $SIZE $BUFF_ORG $NUM"

           WriteVMERegisters v1725pha#*.VMEControl $BERR     ;# set all modules to same setting
           WriteVMERegisters v1725pha#*.CustomSize $SIZE     ;# set all modules to same setting
           WriteVMERegisters v1725pha#*.BufferOrg $BUFF_ORG
           WriteVMERegisters v1725pha#*.EvtsPerBuf $NUM
           WriteVMERegisters v1725pha#*.BLTEventNum $BLT     ;# set all modules to same setting
      }

puts "V1725PHA_Configure finished"

}

proc V1725PHA_DAQ-go {} {puts "V1725PHA_DAQ-go"

   set maxmodule 0
   for {set i 1} {$i <= 16} {incr i} {
      set z [catch {ReadVMERegisterAttr v1725pha#$i.VMEStatus} m]
      if {$z!=0} then {break}
      incr maxmodule
   }
   if {$maxmodule == 0} {return}

   for {set i 1} {$i <= $maxmodule} {incr i} {    ;#   clear data buffers 
      set z [catch {WriteVMERegister v1725pha#$i.Clear 0} m]
   }

   for {set i 1} {$i <= $maxmodule} {incr i} {    ;#  phase 1 - ARM if starting by external signal
      set z [catch {ReadVMERegister v1725pha#$i.AcqControl} m]
      if {$z == 0} {
         if {[expr ($m & 3)] != 0} {
             WriteVMERegister v1725pha#$i.AcqControl [expr ($m & 0xfffb) + 4]
         }
      }
   }

   for {set i 1} {$i <= $maxmodule} {incr i} {    ;#  phase 2 - START if using software control
      set z [catch {ReadVMERegister v1725pha#$i.AcqControl} m]
      if {$z == 0} {
         if {[expr ($m & 3)] == 0} {
             WriteVMERegister v1725pha#$i.AcqControl [expr ($m & 0xfffb) + 4]
         }
      }
   }
}

proc V1725PHA_DAQ-halt {} {puts "V1725PHA_DAQ-halt"

   set maxmodule 0
   for {set i 1} {$i <= 16} {incr i} {
      set z [catch {ReadVMERegisterAttr v1725pha#$i.VMEStatus} m]
      if {$z!=0} then {break}
      incr maxmodule
   }
   if {$maxmodule == 0} {return}

   for {set i 1} {$i <= $maxmodule} {incr i} {    ;#  STOP or DISARM

      set z [catch {ReadVMERegister v1725pha#$i.AcqControl} m]
      if {$z == 0} {WriteVMERegister v1725pha#$i.AcqControl [expr ($m & 0xfffb)]}
   }

   for {set i 1} {$i <= $maxmodule} {incr i} {    ;#   clear data buffers 
      set z [catch {WriteVMERegister v1725pha#$i.Clear 0} m]
   }

}

proc V1725PHA_DAQ-setup {} {puts "V1725PHA_DAQ-setup"

   set maxmodule 0
   for {set i 1} {$i <= 16} {incr i} {
      set z [catch {ReadVMERegisterAttr v1725pha#$i.VMEStatus} m]
      if {$z!=0} then {break}
      incr maxmodule
   }
   if {$maxmodule == 0} {return}

   V1725PHA_Configure
}

proc V1725PHA_DAQ-flush {} {puts "V1725PHA_DAQ-flush"

   for {set i 1} {$i <= $maxmodule} {incr i} {    ;#   clear data buffers 
      set z [catch {WriteVMERegister v1725pha#$i.Clear 0} m]
   }
}

proc V1725PHA_DAQ-reset {} {puts "V1725PHA_DAQ-reset"

   V1725PHA_DAQ-halt
}

proc Dump_Raw_VME_Data_V1725PHA {data} {

        foreach word $data {
           if {[string range $word 0 1] != "0x"} then {set word 0x$word}
           if {$word == 0xaa5555aa} then {
               append info "$word - end of dump\n"
               break
           }
           if {$word == 0x55aaaa55} then {
               append info "$word - end of event\n"
               continue
           }
           append info "$word "
        }

        append info "\n"

   return $info
}

proc define_V1725PHA_config {} {puts "define_V1725PHA_config"
    variable Options
    variable V1725PHA_Base

   set maxmodule 0
   for {set i 1} {$i <= 16} {incr i} {
      set z [catch {ReadVMERegisterAttr v1725pha#$i.VMEStatus} m]
      if {$z!=0} then {break}
      incr maxmodule
   }

   if {$maxmodule > 0} then {DefineConfig "17251 0 [format "0x%x" $V1725PHA_Base]"}

   for {set i 1} {$i <= $maxmodule} {incr i} {

      set z [catch {ReadVMERegisterAttr v1725pha#$i.Output_Buffer} m]
      if {$z!=0} then {
          puts "Attempting to locate register v1725pha#$i.Output_Buffer"
          error $m
      }

      DefineConfig "17251 $i [string range [first $m] 2 end]"
   }
}

proc create_V1725PHA_spectra {} {
    variable V1725PHA_Base
    variable Options 
    variable NumChans

puts "create_V1725PHA_spectra"

   set maxmodule 0
   for {set i 1} {$i <= 16} {incr i} {
      set z [catch {ReadVMERegisterAttr v1725pha#$i.VMEStatus} m]
      if {$z!=0} then {break}
      incr maxmodule
   }

   set UseGroup [ReadNetVar NetVar.UseGroup]

   for {set i 1} {$i <= $maxmodule} {incr i} {

     if {$Options(V1725PHA_Hist_Energy.Enable) == 1} {

        for {set j 0} {$j < $NumChans} {incr j} {   

#    histograms for the computed energy

           set spectrumname v1725pha#$i.E[set j]
           set z [catch {CreateSpectrum1D $spectrumname $Options(V1725PHA_Hist_Energy.channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              puts "Attempting to create spectrum $spectrumname"
              error $m
           } else {

               if {$UseGroup == 0} {
                   set group [expr ($i - 1) + $V1725PHA_Base]
                   set item [expr $j + (0 << 4)]
               } else {
                   set group [expr (($i - 1) * $NumChans) + $j + $V1725PHA_Base]
                   set item 0
               }
               map_spectrum  "$spectrumname $group $item $Options(V1725PHA_Hist_Energy.offset) $Options(V1725PHA_Hist_Energy.shift)"

           }
        }
     }

     if {$Options(V1725PHA_Hist_BaseLine.Enable) == 1} {

        for {set j 0} {$j < $NumChans} {incr j} {   

#    histograms for the base line

           set spectrumname v1725pha#$i.B[set j]
           set z [catch {CreateSpectrum1D $spectrumname $Options(V1725PHA_Hist_BaseLine.channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              puts "Attempting to create spectrum $spectrumname"
              error $m
           } else {

               if {$UseGroup == 0} {
                   set group [expr ($i - 1) + $V1725PHA_Base]
                   set item [expr $j + (4 << 4)]
               } else {
                   set group [expr (($i - 1) * $NumChans) + $j + $V1725PHA_Base]
                   set item 4
               }
               map_spectrum  "$spectrumname $group $item $Options(V1725PHA_Hist_BaseLine.offset) $Options(V1725PHA_Hist_BaseLine.shift)"

           }
        }
     }

     if {$Options(V1725PHA_Hist_TimeX.Enable) == 1} {

        for {set j 0} {$j < $NumChans} {incr j} {   

#    histograms for the time (Extended)

           set spectrumname v1725pha#$i.TX[set j]
           set z [catch {CreateSpectrum1D $spectrumname $Options(V1725PHA_Hist_TimeX.channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              puts "Attempting to create spectrum $spectrumname"
              error $m
           } else {
               if {$UseGroup == 0} {
                   set group [expr ($i - 1) + $V1725PHA_Base]
                   set item [expr $j + (1 << 4)]
               } else {
                   set group [expr (($i - 1) * $NumChans) + $j + $V1725PHA_Base]
                   set item 1
               }
              map_spectrum  "$spectrumname $group $item $Options(V1725PHA_Hist_TimeH.offset) $Options(V1725PHA_Hist_TimeH.shift)"
           }
        }
     }

     if {$Options(V1725PHA_Hist_TimeH.Enable) == 1} {

        for {set j 0} {$j < $NumChans} {incr j} {   

#    histograms for the time (MSW)

           set spectrumname v1725pha#$i.TH[set j]
           set z [catch {CreateSpectrum1D $spectrumname $Options(V1725PHA_Hist_TimeH.channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              puts "Attempting to create spectrum $spectrumname"
              error $m
           } else {
               if {$UseGroup == 0} {
                   set group [expr ($i - 1) + $V1725PHA_Base]
                   set item [expr $j + (2 << 3)]
               } else {
                   set group [expr (($i - 1) * $NumChans) + $j + $V1725PHA_Base]
                   set item 2
               }
              map_spectrum  "$spectrumname $group $item $Options(V1725PHA_Hist_TimeH.offset) $Options(V1725PHA_Hist_TimeH.shift)"
           }
        }
     }

    if {$Options(V1725PHA_Hist_TimeL.Enable) == 1} {

        for {set j 0} {$j < $NumChans} {incr j} {   

#    histograms for the time (LSW)

           set spectrumname v1725pha#$i.TL[set j]
           set z [catch {CreateSpectrum1D $spectrumname $Options(V1725PHA_Hist_TimeL.channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              puts "Attempting to create spectrum $spectrumname"
              error $m
           } else {
               if {$UseGroup == 0} {
                   set group [expr ($i - 1) + $V1725PHA_Base]
                   set item [expr $j + (5 << 3)]
               } else {
                   set group [expr (($i - 1) * $NumChans) + $j + $V1725PHA_Base]
                   set item 5
               }
              map_spectrum  "$spectrumname $group $item $Options(V1725PHA_Hist_TimeL.offset) $Options(V1725PHA_Hist_TimeL.shift)"
           }
        }
     }

    if {$Options(V1725PHA_Hist_TimeF.Enable) == 1} {

        for {set j 0} {$j < $NumChans} {incr j} {   

#    histograms for the Fine Time

           set spectrumname v1725pha#$i.TF[set j]
           set z [catch {CreateSpectrum1D $spectrumname $Options(V1725PHA_Hist_TimeF.channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              puts "Attempting to create spectrum $spectrumname"
              error $m
           } else {
               if {$UseGroup == 0} {
                   set group [expr ($i - 1) + $V1725PHA_Base]
                   set item [expr $j + (3 << 3)]
               } else {
                   set group [expr (($i - 1) * $NumChans) + $j + $V1725PHA_Base]
                   set item 3
               }
              map_spectrum  "$spectrumname $group $item $Options(V1725PHA_Hist_TimeL.offset) $Options(V1725PHA_Hist_TimeL.shift)"
           }
        }
     }


     if {$Options(V1725PHA_Hist_Wave.Enable) == 1} {

        for {set j 0} {$j < $NumChans} {incr j} {   

#    histograms for the waveform

           set spectrumname v1725pha#$i.W[set j]
           set z [catch {CreateSpectrum1D $spectrumname $Options(V1725PHA_Hist_Wave.channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              puts "Attempting to create spectrum $spectrumname"
              error $m
           } else {
              set group  [expr (($i-1) * $NumChans) + $j  + $V1725PHA_Base + 256] 
              set item 0
              map_spectrum  "$spectrumname $group $item $Options(V1725PHA_Hist_Wave.offset) $Options(V1725PHA_Hist_Wave.shift)"
           }
        }
     }

     if {$Options(V1725PHA_Hist_TraceA.Enable) == 1} {

        for {set j 0} {$j < $NumChans} {incr j} {   

#    histograms for the data trace A

           set spectrumname v1725pha#$i.ChA[set j]
           set z [catch {CreateSpectrum1D $spectrumname $Options(V1725PHA_Hist_Wave.channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              puts "Attempting to create spectrum $spectrumname"
              error $m
           } else {
              set group  [expr (($i-1) * $NumChans) + $j + $V1725PHA_Base + 384] 
              set item 0
              map_spectrum  "$spectrumname $group $item $Options(V1725PHA_Hist_Wave.offset) $Options(V1725PHA_Hist_Wave.shift)"
           }
        }
     }

     if {$Options(V1725PHA_Hist_TraceB.Enable) == 1} {

        for {set j 0} {$j < $NumChans} {incr j} {   

#    histograms for the data trace B

           set spectrumname v1725pha#$i.ChB[set j]
           set z [catch {CreateSpectrum1D $spectrumname $Options(V1725PHA_Hist_Wave.channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              puts "Attempting to create spectrum $spectrumname"
              error $m
           } else {
              set group  [expr (($i-1) * $NumChans) + $j + $V1725PHA_Base + 384] 
              set item 1
              map_spectrum  "$spectrumname $group $item $Options(V1725PHA_Hist_Wave.offset) $Options(V1725PHA_Hist_Wave.shift)"
           }
        }
     }

     if {$Options(V1725PHA_Hist_DVP0.Enable) == 1} {

        for {set j 0} {$j < $NumChans} {incr j} {   

#    histograms for the  digital virtual probe 0

           set spectrumname v1725pha#$i.DVP0[set j]
           set z [catch {CreateSpectrum1D $spectrumname $Options(V1725PHA_Hist_Wave.channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              puts "Attempting to create spectrum $spectrumname"
              error $m
           } else {
              set group  [expr (($i-1) * $NumChans) + $j  + $V1725PHA_Base + 384] 
              set item 2
              map_spectrum  "$spectrumname $group $item $Options(V1725PHA_Hist_Wave.offset) $Options(V1725PHA_Hist_Wave.shift)"
           }
        }
     }

   }
}

