

    proc SetTestMode {v} {set rc [catch {set ::VME::TestMode $v} m]}


   variable AcqPaused 0

    proc do_AcqPause {} {
        variable ModuleIndex
        variable ModuleMenu
        variable allmodules
        variable AcqPaused 

puts "do_AcqPause"

        if {$AcqPaused == 1} {return}

        set SAV $ModuleIndex

        foreach ModuleIndex $ModuleMenu  {

          if {$allmodules == 0 && $ModuleIndex != $SAV} {continue}

          WriteRegister AcqControl 0

puts "acq pause"

        }

        set ModuleIndex $SAV

        set AcqPaused 1

    }

    proc do_AcqResume {} {
        variable ModuleIndex
        variable ModuleMenu
        variable allmodules
        variable AcqPaused 

puts "do_AcqResume"

        if {$AcqPaused == 0} {return}

        set SAV $ModuleIndex

        foreach ModuleIndex $ModuleMenu  {

          if {$allmodules == 0 && $ModuleIndex != $SAV} {continue}

          WriteRegister AcqControl 4

puts "acq resume"

        }

        set ModuleIndex $SAV

        set AcqPaused 0

    }

    proc do_IsAcqIdle {} {
        variable ModuleIndex
        variable ModuleName
        variable ModuleMenu
        variable allmodules
        variable AcqPaused 

puts "do_IsAcqIdle"

        set SAV $ModuleIndex

        set rc 1

        foreach ModuleIndex $ModuleMenu  {

          if {$allmodules == 0 && $ModuleIndex != $SAV} {continue}

          if {[expr [ReadRegister AcqStatus] & 4] != 0} {set rc 0; break}

        }

        set ModuleIndex $SAV

        return $rc   ;#  =1 is Idle;  =0 is Active

    }

    proc do_Save {which} {
        variable ModuleIndex
        variable ModuleName
        variable ModuleRegMenu
        variable ChRegMenu
        variable SaveRestoreMenu
        variable HVRegMenu
        variable Name

        set SAV $ModuleIndex

         if {[do_IsAcqIdle] == 0} {InsertLog "Parameter Save is not allowed while acquisition is active";  return}

           set ModuleIndex $which

           set Project $::DataAcquisition::PROJECT
           set DBRootName [set ::[set Project]::DBRootName]
           set DBNodeBase [set ::[set Project]::DBNodeBase]

           set ::[set Project]::DBNodeName [string tolower $ModuleName]#[set ModuleIndex]
           DBCreateNode $DBRootName/$DBNodeBase/[set ::[set Project]::DBNodeName]

           InsertLog "Saving Settings for CAEN [set ModuleName]#[set ModuleIndex] to $DBRootName/$DBNodeBase/[set ::[set Project]::DBNodeName]"

           foreach item $ModuleRegMenu  {
               set saveproc [lindex $item 5]
               if {$saveproc != "null"} {eval $saveproc}
           }

           foreach item $ChRegMenu  {
               set saveproc [lindex $item 5]
               if {$saveproc != "null"} {eval $saveproc}
           }

           if {$Name == "DT5780"} {

               foreach item $HVRegMenu  {
                   set hvproc [lindex $item 5]
                   if {$hvproc != "null"} {eval $hvproc}
               }
           }

           foreach item $SaveRestoreMenu {

               DBSetValue $item  [ReadRegister $item]
           }
 

        set ModuleIndex $SAV
    }

    proc do_SaveAll {} {
        variable ModuleName
        variable ModuleMenu

         if {[do_IsAcqIdle] == 0} {InsertLog "Parameter Save is not allowed while acquisition is active";  return}

        foreach module $ModuleMenu {do_Save $module}

        InsertLog "Settings for All CAEN [set ModuleName] modules updated in DB"

        Elog INFORMATION "Settings for All CAEN [set ModuleName] modules updated in DB"
    }

    proc do_Restore {which} {
        variable ModuleIndex
        variable ModuleName
        variable ModuleMenu
        variable ModuleRegMenu
        variable ChRegMenu
        variable SaveRestoreMenu
        variable HVRegMenu
        variable Name

        variable allmodules
        variable allchannels

        set SAV1 $ModuleIndex
        set SAV2 $allmodules
        set SAV3 $allchannels

         if {[do_IsAcqIdle] == 0} {InsertLog "Parameter Restore is not allowed while acquisition is active";  return}

        set allmodules 0
        set allchannels 0
        set ModuleIndex $which

           set Project $::DataAcquisition::PROJECT
           set DBRootName [set ::[set Project]::DBRootName]
           set DBNodeBase [set ::[set Project]::DBNodeBase]

           set ::[set Project]::DBNodeName [string tolower $ModuleName]#[set ModuleIndex]
           DBCreateNode $DBRootName/$DBNodeBase/[set ::[set Project]::DBNodeName]

       InsertLog "Restoring Settings for CAEN [set ModuleName]#[set ModuleIndex] from $DBRootName/$DBNodeBase/[set ::[set Project]::DBNodeName]"
#       puts "Restoring Settings for CAEN [set ModuleName]#[set ModuleIndex] from $DBRootName/$DBNodeBase/[set ::[set Project]::DBNodeName]"

#        WriteRegister Reset 0   ;# software reset modules

           foreach item $ModuleRegMenu  {
               set restproc [lindex $item 6]
               if {$restproc != "null"} {
                  set z [catch {eval $restproc} msg]
                  if {$z != 0} {InsertLog "restore for $restproc failed $msg"}
               }
           }

           foreach item $ChRegMenu  {
               set restproc [lindex $item 6]
               if {$restproc != "null"} {
                  set z [catch {eval $restproc} msg]
                  if {$z != 0} {InsertLog "restore for $restproc failed $msg"}
               }
           }

           if {$Name == "DT5780"} {

               foreach item $HVRegMenu  {
                   set hvproc [lindex $item 5]
                   if {$hvproc != "null"} {eval $hvproc}
               }
           }

           foreach item $SaveRestoreMenu {
               WriteRegister $item [DBGetValue $item]
           }

        set ModuleIndex $SAV1

        set allmodules $SAV2
        set allchannels $SAV3

    }

    proc do_RestoreAll {} {
        variable ModuleName
        variable ModuleMenu

       if {[do_IsAcqIdle] == 0} {InsertLog "Parameter Restore is not allowed while acquisition is active";  return}

       foreach module $ModuleMenu {do_Restore $module}

#        ::VMEConfig::WriteRegister HasBeenRestored 1

        InsertLog "Settings for All CAEN $ModuleName modules restored from DB"

        Elog INFORMATION "Settings for All CAEN [set ModuleName] modules restored from DB"
    }

    proc ReadDataFIFO {} {

        set datafifo [ReadRegister Output_Buffer]
        InsertLog "read data fifo returned: rc = [first $datafifo]; count=[second $datafifo]"

    }

     proc Show_ROM {} {

        for {set i 0} {$i <= 0x4c} {incr i 4} {
           InsertLog "$i; 0xF0[format %02X $i]; 0x[format %02x [ReadRegister ConfigROM[format %02x $i]]]"
        }

        for {set i 0x80} {$i <= 0x88} {incr i 4} {
           InsertLog "[expr $i]; 0xF0[format %02X $i]; 0x[format %02x [ReadRegister ConfigROM[format %02x $i]]]"
        }
     }


    proc do_Correlation {} {
        variable ModuleIndex
        variable ModuleName
        variable ModuleMenu
        variable allmodules
        variable allchannels
        variable NumChans

         if {[do_IsAcqIdle] == 0} {InsertLog "ADC correlation is not allowed while acquisition is active";  return}

        set SAV $ModuleIndex

        foreach ModuleIndex $ModuleMenu  {

        InsertLog "Performing coincidence setup check module $ModuleIndex "

#    ITRG  bit 2 in CONFIG register

        set reg [ReadRegister Config]
        set vl  [expr ($reg >> 2) & 1]

        if {$vl == 1} {
             InsertLog "CONFIG register bit EN_ITRG has the value 1 (ITRG enabled)"
        } else {
             WriteRegister Config [expr $reg | 0x00000004]
             InsertLog "CONFIG register bit EN_ITRG has been set to 1"
        }

#    Coincidence enable

        for {set i 0} {$i < $NumChans} {incr i} {
           set reg [ReadRegister Ch$i.DPP_CTRL]
           set vl [expr ($reg >> 18) & 3]

           if {$vl == 1} {
               InsertLog "Ch$i DPP_CTRL register TRG_MODE (bits 19:18) has the value 1 (coincidence enabled)"
           } else {
               WriteRegister Ch$i.DPP_CTRL [expr ($reg & 0xfff3fff)  | 0x00040000]
               InsertLog "Ch$i DPP_CTRL register TRG_MODE (bits 19:18) has been set to 1"
           }
        }

#    trigger request width

        for {set i 0} {$i < $NumChans} {incr i} {
           set reg [ReadRegister Ch$i.TrigWidth]
           set vl [expr $reg * 8]

           if {$vl > 0} {
               InsertLog "Ch$i Trig Request Width register has the value $vl ns"
           } else {
               WriteRegister Ch$i.TrigWidth 1
               InsertLog "Ch$i Trig Request Width register has been set to 8ns"
           }
        }

#    coincidence mask register 

        for {set i 0} {$i < $NumChans} {incr i} {
           set reg [ReadRegister Ch$i.TrigValMask]
           set vl $reg

           if {$vl != 0x20000000} {
               InsertLog "Ch$i Trig Val Mask register has the value $vl"
           } else {
               WriteRegister Ch$i.TrigValMask 0x40000000
               InsertLog "Ch$i Trig Request Width register has been set to 0x40000000 (coincidence between channel and ext trigger)"
           }
        }

        }

        set ModuleIndex $SAV

    }

    proc do_Calibration {} {
        variable ModuleIndex
        variable ModuleMenu
        variable allmodules
        variable NumChans

         if {[do_IsAcqIdle] == 0} {InsertLog "ADC calibration is not allowed while acquisition is active";  return}

        set SAV $ModuleIndex

        foreach ModuleIndex $ModuleMenu  {

          if {$allmodules == 0 && $ModuleIndex != $SAV} {continue}

       for {set n 0} {$n < $NumChans} {incr n} {

         set status [ReadRegister Ch$n.Status]
         if {[expr ($status >> 2) & 1] != 0} {
           InsertLog "Channel $n Status  = $status: SPI bus not available; Cannot continue"
           return
         }

         WriteRegister ChCal 0

         for {set i 0} {$i < 10} {incr i} {

            after 100

            set status [ReadRegister Ch$n.Status]
            if {[expr ($status >> 3) & 1] == 1} {break}
         }

         if {$i == 10} {
            InsertLog "Channel $n Status = $status: ADC calibration not complete after 1 sec; Cannot continue"
            return
         }

         InsertLog "Calibration complete for channel $n"

       }

       }
       
       set ModuleIndex $SAV
    }

   proc do_RegisterHelp {W} {
      variable Name
      variable [set W]RegItem

       set f [lindex [set [set W]RegItem] 2]

        set Txtfile [file join $Name [file rootname $f].txt]
        set z [catch {open $Txtfile r} file]
        if {$z != 0} {
            Alert "Unable to access $Txtfile\nInformation coming very soon!!\nFor now read the manual!!"
            return
        }

        set text [read $file]
        close $file

        Alert "$text"
  }

   proc do_ExpertHelp {} {
        variable Name

        set Txtfile [file join $Name Expert.txt]
        set z [catch {open $Txtfile r} file]
        if {$z != 0} {
            Alert "Unable to access $Txtfile\nInformation coming very soon!!\nFor now read the manual!!"
            return
        }

        set text [read $file]
        close $file

        Alert "$text"
  }

