
#    Note:  This is loaded into the namespace PLL

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

    if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""

    variable modulemenu {undefined}
    foreach item $::VMEConfig::ModuleMenu {lappend modulemenu $item}

    variable FirmwareDir
    set FirmwareDir "[file join /etc CAENUpgrader PLL]"
    variable PLLConfigFile "undefined"

    variable indexmenu {1 2 3 4 5 6 7 8 9 10 11 12 13 14 15}
    variable ifmenu [list OPTLINK USB]
    variable imgemenu [list Primary Backup]

    variable ModuleName [first $modulemenu]
    variable ModuleType [first $modulemenu]
    variable ModuleIndex [first $indexmenu]

    variable filelist {undefined}
    variable filename [first $filelist]

    variable iftype [first $ifmenu]
    variable imge  [first $imgemenu]

variable FOP_PAGE_PROG_TH_BUF1  0x0082              ;#   flash page write
variable FOP_PAGE_READ          0x00D2              ;#   flash page read
variable PLL_FLASH_PAGE         1
variable FLASH_PAGE_SIZE        264

    variable OutputClockEnable 0
    variable ClockDelayEnable 0
    variable ClockDelay 0

   proc Help {topic} {
       variable HelpTopic

       set HelpTopic $topic

       do_help
   }

   proc show_variables {} {
        variable ModuleName
        variable ModuleType
        variable LogFlag
        variable ShowLogFlag
        variable OutputClockEnable
        variable ClockDelayEnable
        variable ClockDelay

        InsertLog "ModuleType=$ModuleType; ModuleName=$ModuleName"
        InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag"
        InsertLog "OutputClockEnable=$OutputClockEnable"
   }

     proc do_Program {w} {
          variable ModuleName
          variable ModuleIndex
          variable ModuleType
          variable filename
          variable iftype
          variable imge

       if {$ModuleName == "undefined"} {Alert "please select module to program!"; return}

       set VMEAddress [string range [first [ReadVMERegisterAttr  $ModuleName#$ModuleIndex.FlashData]] 4 end]
       if {[string length $VMEAddress] != 8} {Alert "bad or unsafe VME base address discovered"; return}

       if {$w == 0} {

          if {$imge == "Backup"} {
             Confirm PLL "program PLL using $filename using $iftype $imge into $ModuleName#$ModuleIndex at address 0x$VMEAddress -rbf -param /etc/CAENUpgrader/params/CVupgrade_params_Digitizers_PLL.txt\n\n You have requested to write the BACKUP image. Are you really sure!!"
          } else {
             Confirm PLL "program PLL using $filename using $iftype $imge into $ModuleName#$ModuleIndex at address 0x$VMEAddress -rbf -param /etc/CAENUpgrader/params/CVupgrade_params_Digitizers_PLL.txt"
          }

       } else {

           if {$imge == "Backup"} {set imgeopt "-backup"} else {set imgeopt ""}
 
                    switch $iftype {
                        OPTLINK {
                          if {[expr 0x$VMEAddress & 0x80000000] == [expr 0x80000000]} {
                              set link [expr (0x$VMEAddress >> 20) & 15]
                              set brd  [expr (0x$VMEAddress >> 16) & 15]
                              set address [string range $VMEAddress 4 end]]
                          } else {
                              set link 0
                              set brd 0
                              set address $VMEAddress
                          }

                           set cmd "cvUpgrade $filename $iftype $imgeopt -link $link -bdnum $brd  -VMEbaseaddress $address -rbf -param /etc/CAENUpgrader/params/CVupgrade_params_Digitizers_PLL.txt"
                           InsertLog "executing $cmd\\n"
                           set z [catch {eval exec $cmd} m]
                           InsertLog "Action completed with rc = $z and response \\n$m\\n\\n"
                           Alert "finished"
                        }
                        USB {
                           set cmd "cvUpgrade $filename $iftype $imgeopt -link 0 -VMEbaseaddress $VMEAddress -rbf -param /etc/CAENUpgrader/params/CVupgrade_params_Digitizers_PLL.txt"
                           InsertLog "executing $cmd\\n"
                           set z [catch {eval exec $cmd} m]
                           InsertLog "Action completed with rc = $z and response \\n$m\\n\\n"
                           Alert "finished"
                        }
                        default {Alert "request not supported"}
                    }
       }

     }
   
 
      proc do_ModuleName {w} {
        global env
        variable ModuleName
        variable ModuleType
        variable FirmwareDir
        variable filelist
        variable filename

        set ModuleName [string tolower [second [split $w _]]]
        set ModuleType $w

        set z [catch {file isdirectory $FirmwareDir} m]
        if {$z != 0 || $m == 0} {
            Alert "Unable to access $FirmwareDir or $FirmwareDir is not a directory"
            return
        }

        set arg "-name \"*rbf\" -or -name \"*cfa\""
        set z [catch {eval exec find $FirmwareDir $arg} m]

        if {$z != 0} {
            Alert "Unable to obtain firmware files: $m"
            return
        }

        set filelist {}
        foreach item $m {
            if {[string length $item] == 0} {continue}
            lappend filelist $item
        }

        if {[llength $filelist] == 0} {set filename "undefined"} else {set filename [first $filelist]}

     }

     proc do_ModuleIndex {w} {
          variable ModuleIndex

          set ModuleIndex $w
     }

     proc do_FileName {w} {
          variable filename

          set filename $w
     }

     proc do_InterFace {w} {
          variable iftype

          set iftype $w
     }

     proc do_Image {w} {
          variable imge

          set imge $w
     }

    proc GetPLLConfig {} {
        global env
        variable PLLConfigFile
        variable ModuleIndex
        variable ModuleName
        variable ModuleType
        variable OutputClockEnable
        variable ClockDelayEnable
        variable ClockDelay

   if {$ModuleType == "undefined"} {Alert "Please select a valid module type\n\n\n"; return}

        set PLLConfigFile [file join /etc CAENUpgrader templates [string range [string toupper $ModuleName] 0 4]_template.txt]

        set z [catch {open $PLLConfigFile r} file]
        if {$z != 0} {
            Alert "Unable to access $PLLConfigFile"
            InsertLog "[set file]"
            return
        }

        set Config {}
        set c 0
        foreach item [split [read $file] \n] {
            incr c
            if {$c <= 4} {continue}                    ;#  ignore file header
            if {[string length $item] != 20} {break}   ;#  ignore stuff at end
            set offset 0x[string range $item 1 2]
            set vl 0x[string range $item 17 18]

#             if {$offset == 0x38} {set ClockDelayEnable [expr (($Data & 1) + 1) & 1]}
#             if {$offset == 0x3a} {set ClockDelay [expr ($Data >> 1) & 31]}
#             if {$offset == 0x42} {set vl [expr ($vl & 0xfe) | ~$OutputClockEnable]}

            lappend Config [list $offset $vl]
        }

        close $file

        return $Config
    }

     proc PLLWriteFlash {} {
        variable ModuleIndex
        variable ModuleName
        variable FOP_PAGE_PROG_TH_BUF1  
        variable FOP_PAGE_READ
        variable PLL_FLASH_PAGE 
        variable FLASH_PAGE_SIZE

        set PLLData [GetPLLConfig]
        set flashaddr [expr $PLL_FLASH_PAGE << 9]

        WriteRegister FlashEnable 0     ;#  enable flash

        WriteRegister FlashData  $FOP_PAGE_PROG_TH_BUF1    ;# write OpCode

        WriteRegister FlashData [expr ($flashaddr >> 16) & 255]  ;# write address
        WriteRegister FlashData [expr ($flashaddr >> 8) & 255]
        WriteRegister FlashData [expr $flashaddr & 255]

        for {set i 0; set k 0} {$i < $FLASH_PAGE_SIZE} {incr k} {   ;# write flash page

            if {$k < [llength $PLLData]} {
                 set Offset [first [lindex $PLLData $k]]
                 set Data [second [lindex $PLLData $k]]

            } else {
                 set Offset 255
                 set Data 255
            }
             
             WriteRegister FlashData $Offset
             WriteRegister FlashData $Data

             incr i 2
        }

        WriteRegister FlashEnable 1     ;#  disable flash

        WriteRegister ConfigReload 0    ;#  reload 

        Alert "PLL Flash Written for module [set ModuleName]#[set ModuleIndex]"

        after 250    ;#  allow time for reload 
     }

 
     proc PLLReadFlash {W} {
        variable ModuleIndex
        variable ModuleName
        variable FOP_PAGE_PROG_TH_BUF1  
        variable FOP_PAGE_READ
        variable PLL_FLASH_PAGE 
        variable FLASH_PAGE_SIZE
        variable OutputClockEnable
        variable ClockDelayEnable
        variable ClockDelay

        set PLLData {}
        set flashaddr [expr $PLL_FLASH_PAGE << 9]

        WriteRegister FlashEnable 0     ;#  enable flash

        WriteRegister FlashData  $FOP_PAGE_READ    ;# write OpCode

        WriteRegister FlashData [expr ($flashaddr >> 16) & 255]  ;# write address
        WriteRegister FlashData [expr ($flashaddr >> 8) & 255]
        WriteRegister FlashData [expr $flashaddr & 255]

        for {set i 0; set k 0} {$i < $FLASH_PAGE_SIZE} {incr i 2} {   ;# read flash page
             
             set Offset [format "0x%02x" [ReadRegister FlashData]]
             set Data [format "0x%02x" [ReadRegister FlashData]]

puts "$Offset $Data"

             if {$Offset == 0xff} {continue}

          if {$W == "Y"} {

#             if {$Offset == 0x38} {set ClockDelayEnable [expr (($Data & 1) + 1) & 1]}
#             if {$Offset == 0x3a} {set ClockDelay [expr ($Data >> 1) & 31]}
             if {$Offset == 0x42} {set OutputClockEnable [expr (($Data & 1) + 1) & 1]}
          }

             lappend PLLData [list $Offset $Data]

             if {$Offset == 0x5a} {break}
        }

        WriteRegister FlashEnable 1     ;#  disable flash

        return $PLLData
     }

     proc PLLUpdateFlash {} {
        variable ModuleIndex
        variable ModuleName
        variable FOP_PAGE_PROG_TH_BUF1  
        variable FOP_PAGE_READ
        variable PLL_FLASH_PAGE 
        variable FLASH_PAGE_SIZE
        variable OutputClockEnable
        variable ClockDelayEnable
        variable ClockDelay

        set r38 $ClockDelayEnable          ;# save new values
        set r3a $ClockDelay
        set r42 $OutputClockEnable

        set PLLData [PLLReadFlash N]
        set flashaddr [expr $PLL_FLASH_PAGE << 9]

        WriteRegister FlashEnable 0     ;#  enable flash

        WriteRegister FlashData  $FOP_PAGE_PROG_TH_BUF1    ;# write OpCode

        WriteRegister FlashData [expr ($flashaddr >> 16) & 255]  ;# write address
        WriteRegister FlashData [expr ($flashaddr >> 8) & 255]
        WriteRegister FlashData [expr $flashaddr & 255]

        for {set i 0; set k 0} {$i < $FLASH_PAGE_SIZE} {incr k} {   ;# write flash page

            if {$k < [llength $PLLData]} {
                 set Offset [first [lindex $PLLData $k]]
                 set Data [second [lindex $PLLData $k]]

#                 if {$Offset == 0x38} {     ;# clock delay enable
#                     set Data [expr ($r38 + 1) & 1]
#                 }
#                 if {$Offset == 0x3a} {     ;# delay fine adjust
#                     set Data [expr $r3a << 1]
#                 }
                 if {$Offset == 0x42} {     ;#  clock output enable
                     set op [expr ($r42 + 1) & 1]
                     set Data [expr ($Data & 0xfe) + $op]
                 }
#                if {$Offset == 0x55} {     ;# delay bypass
#                     set op [expr ($r42 + 1) & 1]
#                     set Data [expr ($Data & 0x7e) + ($op << 7)]
#                }

            } else {
                 set Offset 255
                 set Data 255
            }
             
             WriteRegister FlashData $Offset
             WriteRegister FlashData $Data

             incr i 2
        }

        WriteRegister FlashEnable 1     ;#  disable flash

        Alert "PLL Flash Written for module [set ModuleName]#[set ModuleIndex]"

        WriteRegister ConfigReload 0    ;#  reload 

        after 250    ;#  allow time for reload 
     }

     proc PLLReloadFlash {} {

       WriteRegister ConfigReload 0    ;#  reload 

        after 250    ;#  allow time for reload 
     }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

      set cgidata [ncgi::nvlist]

      if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

      if {[llength $cgidata] == 0} then {return}

      if {[llength $cgidata] < 2} then {
         InsertLog "CGI data is too short: $cgidata"
      } else {
        if {[lindex $cgidata 0] != "Widget"} then {
            InsertLog "Invalid CGI data: $cgidata"
        } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]
 
           switch -glob $w {

                RESET    {set started 0}
                CLEAR    {EmptyLog}
                ELOG     {PrintLog}
                RELOAD   {}
                VARIABLES {show_variables}
                HELP     {Help $vl}

                HIDE     {set ShowLogFlag 0}
                SHOW     {set ShowLogFlag 1}
                LOGON    {set LogFlag 1}
                LOGOFF   {set LogFlag 0}

                TYPE    {do_ModuleName $vl}
                INDEX   {do_ModuleIndex $vl}
                FILE    {do_FileName $vl}
                IF      {do_InterFace $vl}
                IMAGE   {do_Image $vl}

                PLLOUTENABLE {variable OutputClockEnable; if {$vl == "true"} {set OutputClockEnable 1} else {set OutputClockEnable 0}}
                PLLCLKDELAY  {variable ClockDelayEnable; if {$vl == "true"} {set ClockDelayEnable 1} else {set ClockDelayEnable 0}}
                PLLREADFLASH  {PLLReadFlash Y}
                PLLWRITEFLASH {PLLWriteFlash}
                PLLUPDATEFLASH {PLLUpdateFlash}
                PLLRELOADFLASH {PLLReloadFlash}

                PROGRAM {do_Program 0}
                CONFIRM {do_Program 1}
      
                undefined {}
                default  {InsertLog "unexpected cgi data:  $cgidata"}
            }
         }
       }
    }


}  ;# end of if {$started == 0}

