

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1


    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""

    variable allmodules 0
    variable offline 0

   variable SoftTrigRun 0

    variable Rmsg
    variable Wmsg

    variable ModuleName v1495v2
    variable ModuleMenu {}
    variable ModuleAddress {}
    variable ModuleIndex 1

    variable V1495V2RegisterMapA {}
    lappend V1495V2RegisterMapA {FirmwareRev Firmware 0x800c "readonly"}
    lappend V1495V2RegisterMapA {FirmwareDate Date 0x1040 "readonly"}
    lappend V1495V2RegisterMapA {FirmwareVersion Revision 0x100c "readonly"}

    variable V1495V2RegisterMapB {}
    lappend V1495V2RegisterMapB {Scratch16 Scratch16 0x8018 ""}
    lappend V1495V2RegisterMapB {Scratch32 "Scratch32" 0x8020 ""}

    variable DPPISSA {}
    lappend DPPISSA     {GateWidth "Gate Width" 0x1010 ""}
    lappend DPPISSA     {GateDelay "Gate Delay" 0x1014 ""}
    lappend DPPISSA     {Ctrl      "Ctrl" 0x1018  ""}
    lappend DPPISSA     {RdOutCtrl "Read Out Ctrl" 0x101c ""}
    lappend DPPISSA     {TrigReqCnt  "Trig Req Count" 0x1030 "readonly"}
    lappend DPPISSA     {TrigAccCnt  "Trig Acc Count" 0x1034 "readonly"}
    lappend DPPISSA     {RdOutStat "Read Out Status" 0x103c "readonly"}

    variable V1495V2RegisterMap {}
    foreach item $V1495V2RegisterMapA {lappend V1495V2RegisterMap $item}
    foreach item $V1495V2RegisterMapB {lappend V1495V2RegisterMap $item}
    foreach item $DPPISSA {lappend V1495V2RegisterMap $item}


    variable Ctrl 0
    variable Ctrl.B0 0
    variable Ctrl.B1 0
    variable Ctrl.B2 0
    variable Ctrl.B3 0
    variable Ctrl.B8 0
    variable Ctrl.B9 0
    variable Ctrl.B10 0
    variable Ctrl.B11 0
    variable Ctrl.B12 0
    variable Ctrl.B13 0
    variable Ctrl.B14 0
    variable Ctrl.B15 0


    variable SaveRestoreMenu {}


     if {$LogFlag == 1} {InsertLog "Started: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

   proc do_ExpertHelp {} {

        set Txtfile [file join V1495V2 Expert.txt]
        set z [catch {open $Txtfile r} file]
        if {$z != 0} {
            Alert "Unable to access $Txtfile\nInformation coming very soon!!\nFor now read the manual!!"
            return
        }

        set text [read $file]
        close $file

        Alert "$text"
  }

   proc show_variables {} {
        variable ModuleName
        variable ModuleIndex
        variable ModuleMenu
        variable allmodules
        variable LogFlag
        variable ShowLogFlag
        variable Rmsg
        variable Wmsg

             InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag"
             InsertLog "ModuleMenu=$ModuleMenu; ModuleName=$ModuleName; ModuleIndex=$ModuleIndex; "
             InsertLog "allmodules=$allmodules"
             InsertLog "Rmsg=$Rmsg"
             InsertLog "Wmsg=$Wmsg"
             InsertLog "Firmware Date=[ReadRegister FirmwareDate]; Firmware Version=[ReadRegister FirmwareVersion]"
   }

   proc do_Select {i} {    ;# select module
        variable ModuleIndex

         set ModuleIndex $i
         UpdateModule
   }

    proc UpdateModule {} {
        variable ModuleName
        variable ModuleIndex
       variable Ctrl
    variable Ctrl.B0 0
    variable Ctrl.B1 0
    variable Ctrl.B2 0
    variable Ctrl.B3 0
    variable Ctrl.B8 0
    variable Ctrl.B9 0
    variable Ctrl.B10 0
    variable Ctrl.B11 0
    variable Ctrl.B12 0
    variable Ctrl.B13 0
    variable Ctrl.B14 0
    variable Ctrl.B15 0

       set Ctrl [ReadRegister Ctrl]

       set Ctrl.B0 [expr $Ctrl & 3]
       set Ctrl.B1 [expr ($Ctrl >> 1) & 1]
       set Ctrl.B2 [expr ($Ctrl >> 2) & 1]
       set Ctrl.B3 [expr ($Ctrl >> 3) & 1]
       set Ctrl.B8 [expr ($Ctrl >> 8) & 1]
       set Ctrl.B9 [expr ($Ctrl >> 9) & 1]
       set Ctrl.B10 [expr ($Ctrl >> 10) & 1]
       set Ctrl.B11 [expr ($Ctrl >> 11) & 1]
       set Ctrl.B12 [expr ($Ctrl >> 12) & 1]
       set Ctrl.B13 [expr ($Ctrl >> 13) & 1]
       set Ctrl.B14 [expr ($Ctrl >> 14) & 1]
       set Ctrl.B15 [expr ($Ctrl >> 15) & 1]

   }

    proc click-SETTING {w vl} {

       InsertLog "SETTING: write register $w $vl"

        WriteRegister $w $vl
    }


    proc do_Save {which} {
        variable ModuleName
        variable ModuleIndex
        variable SaveRestoreMenu

       set SAV $ModuleIndex

           set ModuleIndex $which
           InsertLog "Saving Settings for CAEN [set ModuleName]#[set ModuleIndex]"

           set Project $::DataAcquisition::PROJECT
           set DBRootName [set ::[set Project]::DBRootName]
           set DBNodeBase [set ::[set Project]::DBNodeBase]

           set ::[set Project]::DBNodeName [string tolower $ModuleName]#[set ModuleIndex]
           DBCreateNode $DBRootName/$DBNodeBase/[set ::[set Project]::DBNodeName]

           DBSetValue Scratch16   [ReadRegister Scratch16]
           DBSetValue Scratch32   [ReadRegister Scratch32]

	foreach item $SaveRestoreMenu {
	    DBSetValue $item  [ReadRegister $item]
	}

        set ModuleIndex $SAV
    }

    proc do_SaveAll {} {
        variable ModuleName
        variable ModuleMenu

        foreach module $ModuleMenu {do_Save $module}

        InsertLog "Settings for All CAEN [set ModuleName] modules updated in DB"

        Elog INFORMATION "Settings for All CAEN [set ModuleName] modules updated in DB"
    }

   proc do_Restore {which} {
        variable ModuleIndex
        variable ModuleName
        variable SaveRestoreMenu

        set SAV1 $ModuleIndex

        set ModuleIndex $which

        InsertLog "Restoring Settings for CAEN [set ModuleName]#[set ModuleIndex]"

           set Project $::DataAcquisition::PROJECT
           set DBRootName [set ::[set Project]::DBRootName]
           set DBNodeBase [set ::[set Project]::DBNodeBase]

           set ::[set Project]::DBNodeName [string tolower $ModuleName]#[set ModuleIndex]
           DBCreateNode $DBRootName/$DBNodeBase/[set ::[set Project]::DBNodeName]

       foreach item $SaveRestoreMenu {

	   WriteRegister $item [DBGetValue $item]
       }

        set ModuleIndex $SAV1
    }

    proc do_RestoreAll {} {
        variable ModuleName
        variable ModuleMenu

       foreach module $ModuleMenu {do_Restore $module}

        ::VMEConfig::WriteRegister HasBeenRestored 1

        InsertLog "Settings for All CAEN [set ModuleName] modules restored from DB"

        Elog INFORMATION "Settings for All CAEN [set ModuleName] modules restored from DB"
    }

   proc do_SoftTrig {n} {
      variable SoftTrigRun
        variable ModuleName
        variable ModuleIndex

      switch $n {
        1     {WriteRegister Arm 0}
        0     {puts "V1495V2 finished SoftTrig run"; set SoftTrigRun 0}
        100   {set SoftTrigRun 1; after 100 ::V1495V2::do_SoftTrig 99}
        99999 {puts "V1495V2 starting SoftTrig run"; set SoftTrigRun 1; after 100 ::V1495V2::do_SoftTrig 99998}
        99998 {if {$::V1495V2::SoftTrigRun ==0} return; WriteRegister Arm 0; after 100 ::V1495V2::do_SoftTrig 99998}
        default  {if {$::V1495V2::SoftTrigRun ==0} return; WriteRegister Arm 0; if {$n > 0} {after 100 ::V1495V2::do_SoftTrig [expr $n-1]}}
      }
   }

    proc do_AcqStart {} {


    }

    proc do_AcqHalt {} {


    }

    proc do_AcqArm {} {


    }

     proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag
       variable ModuleIndex
       variable ModuleName

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {
               set w [lindex $cgidata 1]

               switch -glob [lindex $w 0] {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   MODULE   {do_Select [lindex $w 1]}

                   EXPERT {
                      switch [lindex $w 1] {
                        Help      {do_ExpertHelp}
                        FirmwareUpdate {Alert "Start firmware update from VME Control page"}
                        SoftTrig  {do_SoftTrig [lindex $w 2]}
                        AcqStart  {do_AcqStart}
                        AcqHalt   {do_Acqhalt}
                        AcqArm    {do_AcqArm}
                        Scratch   {WriteRegister Scratch32 12345}
                        default     {}
                      }
                   }
                   EXPERTHELP    {do_ExpertHelp}

                   SAVEALL      {do_SaveAll}
                   RESTALL      {do_RestoreAll}
                   SAVE         {do_Save $ModuleIndex}
                   RESTORE      {do_Restore $ModuleIndex}

                   SETTING     {click-SETTING [lindex $w 1] [lindex $w 2]}

                   REDISPLAY  {} 

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data: [lindex $w 0]: $cgidata"}
               }
           }
       }
       UpdateModule
    }

}   ;# end of if {$started == 0}

