

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
    UpdateModule
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0
    variable DebugFlag 0

    variable ShowLogFlag 0

    variable JS ""

    variable allmodules 0
    variable allchannels 0

    variable ModuleName v1725pha
    variable ModuleMenu {}
    variable ModuleAddress {}
    variable ModuleIndex 1

    variable SoftTrigRun 0
    variable SliderDelay 3000

    variable NumChans 16
    variable FamilyCode -1
    variable Name V1725PHA

   set z [catch {ReadRegister BoardInfo} BoardInfo]
   if {$z == 0 && [string range $BoardInfo 6 end] != "dead"} {
       set FamilyCode [expr $BoardInfo & 0xff]
       set NumChans [expr ($BoardInfo >> 16) & 0xff]
   }


#    for the Register Menus each item is a list
#      0) name for menu
#      1) register
#      2) file containing support implementation
#      3) Display procedure  (null if none)
#      4) parameter update procedure   (null if none)
#      5) parameter save procedure (null if none)
#      6) parameter restore procedure (null if none)

    variable ModuleRegMenu { \
       {"Configuration (0x8000)"             Config        Config.tml        GetConfig DrawConfig null null} \
       {"Buffer Organisation (0x800c)"       BufferOrg     BuffOrg.tml       GetBuffOrg DrawBuffOrg null null} \
       {"Acquisition Window(0x8020)"         RecLen        RecLen.tml      GetRecLen DrawRecLen null null} \
       {"Start/Stop Run Delay (0x8170)"      RunDelay      RunDelay.tml      GetRunDelay DrawRunDelay null null} \
       {"Channel Enable Mask (0x8120)"       Enable        ChEnable.tml      GetChEnable DrawChEnable null null} \
       {"Trigger Source Enable (0x810c)"  TrigSrcEnable TrigSrcEnable.tml GetTrigSrcEnable DrawTrigSrcEnable null null} \
       {"FP Trigger Out Enable (0x8100)" FPTrigOutEnable  FPTrigEnable.tml  GetFPTrigEnable DrawFPTrigEnable null null} \
       {"FP I/O Control (0x811c)"             FPIOControl   FPIOCtrl.tml      GetFPIO DrawFPIO null null} \
       {"Acquisition Control (0x8100)"        AcqControl    AcqCtrl.tml       GetAcqCtrl DrawAcqCtrl null null} \
       {"Acquisition Status (0x8104)"         AcqStatus     AcqStatus.tml     GetAcqStatus DrawAcqStatus null null} \
       {"VME Control (0xef00)"                VMECtrl       VMECtrl.tml       GetVMECtrl DrawVMECtrl null null} \
       {"VME Status (0xef04)"                 VMEStatus     VMEStatus.tml     GetVMEStatus DrawVMEStatus null null} \
       {"System Options"                      SystemOpts    SystemOpts.tml    GetSystemOpts DrawSystemOpts null null} \
    }

    variable ChRegMenu { \
       {"Algorithm Control (0x1n80)"   AlgorithmControl AlgorithmControl.tml GetAlgorithmControl DrawAlgorithmControl \
                                    SaveAlgorithmControl RestAlgorithmControl} \
       {"BaseLine Hold Off (0x1n7c)"    BaseLineHoldOff BaseLineHoldOff.tml GetBaseLineHoldOff DrawBaseLineHoldOff \
                               SaveBaseLineHoldOff RestBaseLineHoldOff} \
       {"DC Offset (0x1n98)"   DCOffset  DCOffset.tml GetDCOffset DrawDCOffset SaveDCOffset RestDCOffset} \
       {"Decay Time (0x1n68)"       DecayTime DecayTime.tml GetDecayTime DrawDecayTime SaveDecayTime RestDecayTime} \
       {"Dynamic Range (0x1n28)"   DynRnge  DynRnge.tml GetDynRnge DrawDynRnge SaveDynRnge RestDynRnge} \
       {"Input Rise Time (0x1n58)"  InputRiseTime InputRiseTime.tml GetInputRiseTime DrawInputRiseTime \
                           SaveInputRiseTime RestInputRiseTime} \
       {"Local Trigger (0x1nA0)"  LocalTrigger LocalTrigger.tml GetLocalTrigger DrawLocalTrigger SaveLocalTrigger RestLocalTrigger} \
       {"Peak Hold Off (0x1n78)"    PeakHoldOff PeakHoldOff.tml GetPeakHoldOff DrawPeakHoldOff \
                           SavePeakHoldOff RestPeakHoldOff} \
       {"Peaking Time (0x1n64)"     PeakingTime PeakingTime.tml GetPeakingTime DrawPeakingTime \
                           SavePeakingTime RestPeakingTime} \
       {"Pre Trigger Window (0x1n38)"    PreTrig  PreTrig.tml   GetPreTrig DrawPreTrig SavePreTrig RestPreTrig} \
       {"RTD Window Width (0x1n70)" RTDWinWidth RTDWinWidth.tml GetRTDWinWidth DrawRTDWinWidth \
                           SaveRTDWinWidth RestRTDWinWidth} \
       {"Trapezoid Flat Top (0x1n60)"   TrapFlatTop TrapFlatTop.tml GetTrapFlatTop DrawTrapFlatTop \
                               SaveTrapFlatTop RestTrapFlatTop} \
       {"Trapezoid Rise Time (0x1n5c)"  TrapRiseTime TrapRiseTime.tml GetTrapRiseTime DrawTrapRiseTime \
                               SaveTrapRiseTime RestTrapRiseTime} \
       {"Trigger and Timing Filter Smoothing (0x1n54)"  AvWindow AveragingWindow.tml GetAvWindow DrawAvWindow \
                           SaveAvWindow RestAvWindow} \
       {"Trigger Hold Off (0x1n74)" TrigHoldOff TrigHoldOff.tml GetTrigHoldOff DrawTrigHoldOff \
                           SaveTrigHoldOff RestTrigHoldOff} \
       {"Trigger Threshold (0x1n6c)"     Threshold TrigThreshold.tml GetThreshold DrawThreshold \
                                SaveThreshold RestThreshold} \
       {"Trigger Request Width (0x1n84)"   TrigWidth TrigWidth.tml GetTrigWidth DrawTrigWidth SaveTrigWidth RestTrigWidth} \
       {"Trig Val Mask (0x81nm)"   TrigValMask  TrigValMask.tml GetTrigValMask DrawTrigValMask SaveTrigValMask RestTrigValMask} \
    }



#   registers for Save/Restore not handled by above (module registers)
    variable SaveRestoreMenu {Enable Config BufferOrg TrigSrcEnable FPTrigOutEnable FPIOControl \
                 AcqControl RecLen BLTEventNum}


    variable ModuleRegItem [lindex $ModuleRegMenu 0]
    variable ModuleReg [lindex $ModuleRegItem 0]

    variable ChRegItem [lindex $ChRegMenu 0]
    variable ChReg [lindex $ChRegItem 0]


#    source all implementation files to load implementation code
  foreach item $ModuleRegMenu  {
     source [file join V1725PHA [lindex $item 2]]
     set updateproc [lindex $item 3]
     if {$updateproc != "null"} {eval $updateproc}
  }

  foreach item $ChRegMenu  {
     source [file join V1725PHA [lindex $item 2]]
     set updateproc [lindex $item 3]
     if {$updateproc != "null"} {eval $updateproc}
  }

   proc show_variables {} {
        variable ModuleIndex
        variable ModuleName
        variable allchannels
        variable allmodules
        variable LogFlag
        variable DebugFlag
        variable ShowLogFlag
        variable ModuleRegItem
        variable ChRegItem
        variable Rmsg
        variable Wmsg
        variable SoftTrigRun

             InsertLog "ModuleName=$ModuleName; ModuleIndex=$ModuleIndex"
             InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag; DebugFlag=$DebugFlag"
             InsertLog "allchannels=$allchannels; allmodules=$allmodules"
             InsertLog "ModuleReg=$ModuleRegItem"
             InsertLog "ChannelReg=$ChRegItem"
             InsertLog "SoftTrigRun=$SoftTrigRun"
             InsertLog "Rmsg=$Rmsg"
             InsertLog "Wmsg=$Wmsg"
   }

   proc do_Select {i} {    ;# select module
        variable ModuleIndex

         set ModuleIndex $i
         UpdateModule
   }

   proc UpdateModule {} {

       do_UpdateModuleRegisters
       do_UpdateChannelRegisters
   }

   proc UpdateChannel {} {

       do_UpdateChannelRegisters
   }

   proc do_UpdateModuleRegisters {} {
        variable ModuleRegMenu

        foreach item $ModuleRegMenu  {
            set updateproc [lindex $item 3]
            if {$updateproc != "null"} {eval $updateproc}
        }
   }

   proc do_UpdateChannelRegisters {} {
       variable ChRegMenu
       foreach item $ChRegMenu  {
           set updateproc [lindex $item 3]
           if {$updateproc != "null"} {eval $updateproc}
       }
   }

   proc do_SelectModuleRegister {w} {
        variable ModuleReg
        variable ModuleRegItem
        variable ModuleRegMenu

      foreach item $ModuleRegMenu  {
         set name [lindex $item 0]
         if {"$w" == "$name"} {
             set ModuleRegItem $item
             set ModuleReg [lindex $item 1]
         }
      }
   }

   proc do_SelectChannelRegister {w} {
        variable ChReg
        variable ChRegItem
        variable ChRegMenu

      foreach item $ChRegMenu  {
         set name [lindex $item 0]
         if {"$w" == "$name"} {
             set ChRegItem $item
             set ChReg [lindex $item 1]
         }
      }
   }

    proc do_SetModuleRegister {w v} {
        variable ModuleIndex
        variable ModuleMenu
        variable allmodules
        variable DebugFlag
        variable $w

        if {$DebugFlag == 1} {InsertLog "do_SetModuleRegister: $w = $v"}

       if {[do_IsAcqIdle] == 0} {do_AcqPause}

       set SAV $ModuleIndex

        foreach ModuleIndex $ModuleMenu  {

          if {$allmodules == 0 && $ModuleIndex != $SAV} {continue}

        switch -glob $w {
            Config.*        {set $w $v; SetConfig}
            BuffOrg         {set $w $v; SetBuffOrg}
            ChEnableMask*   {set $w $v; SetChEnable}
            FPTrigEnable*   {set $w $v; SetFPTrigEnable}
            TrigSrcEnable*  {set $w $v; SetTrigSrcEnable}
            FPIO*           {set $w $v; SetFPIO}
            RecLen          {set $w $v; SetRecLen}
            PostTrig        {set $w $v; SetPostTrig}
            RunDelay        {set $w $v; SetRunDelay}

            ReConfig        {WriteRegister ConfigReload 0; after 1000}
            Reset           {WriteRegister Reset 0; after 1000}

            AcqControl  -
            Clear -
            FlushEvBlk -
            SoftwareSyncReset -
            EvtsPerBuf -
            BLTEventNum -
            BufferOrg -
            SoftTrig        {WriteRegister $w $v}

            AcqCtrl*        {set $w $v; SetAcqCtrl}
            AcqStatus*      {}
            VMECtrl*        {set $w $v; SetVMECtrl}
            VMEStatus*      {}

            default {set $w $v}
        }

        }
       set ModuleIndex $SAV

       do_AcqResume
   }

    proc do_SetChannelRegister {w i vl} {
        variable ModuleIndex
        variable ModuleMenu
        variable allmodules
        variable allchannels
        variable NumChans
        variable DebugFlag

        if {$DebugFlag == 1} {InsertLog "do_SetChannelRegister: Ch$i.$w = $vl"}

       if {[do_IsAcqIdle] == 0} {do_AcqPause}

       set SAV $ModuleIndex

        foreach ModuleIndex $ModuleMenu  {

          if {$allmodules == 0 && $ModuleIndex != $SAV} {continue}

        for {set j 0} {$j < $NumChans} {incr j} {
           if {$allchannels == 0 && $j != $i} {continue}
           variable Ch$j.$w; set Ch$j.$w $vl
        }

        switch -glob $w {
            TrigValMask* {
                for {set j 0} {$j < 8} {incr j} {
                    if {$allchannels == 0 && $j != $i} {continue}
                    SetTrigValMask $j
#variable Ch$j.TrigValMask
#InsertLog "SetTrigValMask Ch$j [format %08x [set Ch$j.TrigValMask]]"
                }
            }
            AlgorithmControl* {
                for {set j 0} {$j < $NumChans} {incr j} {
                    if {$allchannels == 0 && $j != $i} {continue}
                    SetAlgorithmControl $j
#variable Ch$j.AlgorithmControl
#InsertLog "SetAlgorithmControl Ch$j [format %08x [set Ch$j.AlgorithmControl]]"
                }
            }
            LocalTrigger* {
                for {set j 0} {$j < $NumChans} {incr j} {
                    if {$allchannels == 0 && $j != $i} {continue}
                    SetLocalTrigger $j
#variable Ch$j.LocalTrigger
#InsertLog "SetLocalTrigger Ch$j [format %08x [set Ch$j.LocalTrigger]]"
                }
            }
            ExtTriggerMode -
            TrapReScale -
            BaseLineAvWin -
            Decimation -
            PeakAvWin -
            DigitalGain -
            InvertInput   {
                for {set j 0} {$j < $NumChans} {incr j} {
                    if {$allchannels == 0 && $j != $i} {continue}
                    WriteRegister Ch$j.$w $vl
                }
            }
            DCOffset -
            TrigWidth -
            PreTrig {
                for {set j 0} {$j < $NumChans} {incr j} {
                    if {$allchannels == 0 && $j != $i} {continue}
                    Set$w $vl
                }
            }
            default {if {$allchannels == 0} {WriteRegister Ch$i.$w $vl} else {WriteRegister $w $vl}}
       }
       }

       do_AcqResume

      set ModuleIndex $SAV
   }

   proc do_SoftTrig {n} {

      switch $n {
        1     {WriteRegister SoftTrig 1}
        0     {puts "V1725PHA finished SoftTrig run"; set ::V1725PHA::SoftTrigRun 0}
        100   {set ::V1725PHA::SoftTrigRun 1; after 100 ::V1725PHA::do_SoftTrig 99}
        99999 {puts "V1725PHA starting SoftTrig run"; set ::V1725PHA::SoftTrigRun 1; after 100 ::V1725PHA::do_SoftTrig 99998}
        99998 {if {$::V1725PHA::SoftTrigRun ==0} return; do_WriteSoftTrig; after 100 ::V1725PHA::do_SoftTrig 99998}
        default  {if {$::V1725PHA::SoftTrigRun ==0} return; do_WriteSoftTrig; if {$n > 0} {after 100 ::V1725PHA::do_SoftTrig [expr $n-1]}}
      }
   }

   proc do_WriteSoftTrig {} {
      global errorCode errorInfo
      variable Wmsg

       set r [set ::V1725PHA::ModuleName]#[set ::V1725PHA::ModuleIndex].SoftTrig
       set z [catch {::namespace inscope ::urn:VMEAccessServer WriteRegister $r 1} Wmsg]
       if {$z != 0} {
           InsertLog "WriteRegister $r failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

     proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable DebugFlag
       variable ShowLogFlag
       variable ModuleIndex

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {
               set w [lindex $cgidata 1]

               switch -glob [lindex $w 0] {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {UpdateModule}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}
                   DEBUGON    {set DebugFlag 1}
                   DEBUGOFF   {set DebugFlag 0}

                   ALLCHANS   {variable allchannels; set allchannels [expr ($allchannels + 1) & 1]}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   MODULE   {do_Select [lindex $w 1]}

                   MREGISTER      {do_SelectModuleRegister [string range $w 10 end]}
                   MREGISTERHELP  {do_RegisterHelp Module}

                   EXPERT {
                      switch [lindex $w 1] {
                        Help      {do_ExpertHelp}
                        FirmwareUpdate {Alert "Start firmware update from VME Control page"}
                        SoftTrig  {do_SoftTrig [lindex $w 2]}
                        Reset -
                        Clear -
                        SoftwareSyncReset -
                        FlushEvBlk -
                        ReConfig  {do_SetModuleRegister [lindex $w 1] 0}
                        AcqStart  {source [file join V1725PHA AcqStart.tcl]}
                        AcqHalt   {source [file join V1725PHA AcqHalt.tcl]}
                        DataFIFO    {ReadDataFIFO}
                        Scratch     {WriteRegister Scratch 12345}
                        ROM       {Show_ROM}
                        EnableTestMode   {SetTestMode 1}
                        EnableNormalMode {SetTestMode 0}
                        default   {}
                      }
                   }
                   EXPERTHELP    {do_ExpertHelp}

                   CHREGISTER      {do_SelectChannelRegister [string range $w 11 end]}
                   CHREGISTERHELP  {do_RegisterHelp Ch}

                   MSETTING      {do_SetModuleRegister [lindex $w 1] [lindex $w 2]}
                   MSETTINGS     {do_SetModuleRegister [lindex $cgidata 4] [lindex $cgidata 5]}
 
                   CHSETTING     {do_SetChannelRegister [lindex $w 1] [lindex $w 2] [lindex $w 3]}
                   
                   SAVEALL      {do_SaveAll}
                   RESTALL      {do_RestoreAll}
                   SAVE         {do_Save $ModuleIndex}
                   RESTORE      {do_Restore $ModuleIndex}

                   CORRELATION  {do_Correlation}
                   CALIBRATION  {do_Calibration}                   
                   PAUSE        {do_AcqPause}
                   RESUME       {do_AcqResume}

                   REDISPLAY  {} 

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data: [lindex $w 0]: $cgidata"}
               }
           }
       }
       UpdateModule
    }

}   ;# end of if {$started == 0}


     if {$LogFlag == 1} {InsertLog "Started: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

