
#    RunControl specific for data acquisition based on CAEN digitial ADCs

global env

namespace eval DataAcquisition {
     variable PROJECT; if {![info exists PROJECT]} {set PROJECT CAEN}
     variable ACQSERVERS; if {![info exists ACQSERVERS]} {set ACQSERVERS $env(ComputerName)}
     variable ACQSERVER; if {![info exists ACQSERVER]} {set ACQSERVER [first $ACQSERVERS]}
}

namespace eval $::DataAcquisition::PROJECT {
    variable DBRootName; if {![info exists DBRootName]} {set DBRootName [file join EXPERIMENTS $::DataAcquisition::PROJECT]}
    variable DBNodeBase; if {![info exists DBNodeBase]} {set DBNodeBase 2015}
    variable DBNodeName; if {![info exists DBNodeName]} {set DBNodeName $env(ComputerName)}
}


puts "loading tcl/CAENRunControl.tcl for namespace [namespace current]"

   set z [catch {package require RunControlServer} m]
   if {$z != 0} {puts "RunControl returned z=$z and $m"} else {puts "RunControl loaded"}

#    provides the following 

#   Appdo_Setup
#   Appdo_Stop
#   Appdo_Go
#   Appdo_Reset
#   Appdo_SetOption
#   Appdo_GetOption
#   Appdo_GetCounters
#   Appdo_GetRates
#   Appdo_GetState


   global env

     set f [file join $env(MIDASBASE) TclHttpd Html RunControl implementation.tcl]
     set env(ProjectRunControlImplementation) $f
     set z [catch {source $f} m]
     if {$z != 0} {puts "CAEN RunControl returned z=$z and $m"} else {puts "CAEN RunControl loaded"}

     set f [file join $env(MIDASBASE) TclHttpd Html CAEN RunControl implementation.tcl]
     set env(ProjectRunControlImplementation) $f
     set z [catch {source $f} m]
     if {$z != 0} {puts "CAEN RunControl returned z=$z and $m"} else {puts "CAEN RunControl loaded"}

global MIDAS_CAENRunControl_Exists
set MIDAS_CAENRunControl_Exists 1

package provide CAENRunControl 1.0
